unit list;

interface


type
PListRecord=^TListRecord;
TListRecord=record
data:Pointer;
next,prev:PListRecord;
end;

TMyList=class
public
  datatype:integer;
  constructor Create;
  destructor Destroy;
  procedure Push(data:Pointer);
  //function Pop():POinter;
  function Size:integer;
  function First:Pointer;
  function Next:Pointer;
  function Prev:Pointer;
  function Cur:Pointer;
  procedure Delete;
  procedure PrintLast;
protected
  head,curitem:PListRecord;
  sizevaL:integer;
end;

implementation

uses dialogs;


constructor TMyList.Create;
begin
  head:=nil;
  curitem:=nil;
  sizEval:=0;
end;

destructor TMyList.Destroy;
var
cur,t:PListRecord;
begin
if head<>nil then
begin
cur:=head;
  while cur^.next<>nil do
    begin
    Dispose(cur^.data);
    t:=cur^.next;
    Dispose(cur);
    cur:=t;
    end;
end;
end;

function TMyList.Cur:Pointer;
begin
if Assigned(curitem) then
  result:=curitem.data else
  result:=nil;
end;

procedure TMyList.Delete;
begin
  if Assigned(curitem) then
    begin
      if Assigned(curitem.prev) then
        if Assigned(curitem.next) then
        curitem.prev.next:=curitem.next.prev else
        curitem.prev.next:=nil;
      if Assigned(curitem.next) then
        if Assigned(curitem.prev) then
         curitem.next.prev:=curitem.prev.next else
         curitem.next.prev:=nil;
      Dispose(curitem);
    end;
end;

procedure TMyList.Push(data:Pointer);
begin
  if head=nil then
    begin
    New(head);
    New(head.data);
    head.data:=data;
    head.next:=nil;
    head.prev:=nil;
    end else
      begin
      New(head^.next);
      head^.next^.prev:=head;
      head:=head^.next;
      New(head.data);
      head.data:=data;
      head.next:=nil;
      end;
    inc(sizeval);
    curitem:=head;
end;

function TMyList.Size;
begin
result:=sizeval;
end;


function TMyList.First:POinter;
begin
if Assigned(head) then
begin
  result:=head^.data;
  curitem:=head;
end else result:=nil;
end;

function TMyList.Next:Pointer;
begin
  if Assigned(curitem) then
  begin
  if Assigned(curitem.next) then  
    result:=curitem^.next.data else
    result:=nil;
  curitem:=curitem^.next;
  end else
  result:=nil;
end;

function TMyList.Prev:Pointer;
begin
  if Assigned(curitem) then
  begin
  if Assigned(curitem.prev) then
    result:=curitem^.prev^.data else
    result:=nil;
  curitem:=curitem^.prev;
  end else
  result:=nil;
end;

procedure TMyList.PrintLast;
begin
  showmessage(string(First));
end;
end.
