unit queue;
interface
uses stack;
type
TQueue=class(TStack)
  OnTaskComplete:procedure(task:Pointer);
  constructor Create;
  procedure Push(data:Pointer);
  function Pop:pointer;
  procedure AddString(s:string);
  private
  tail:PStackRecord;
end;

implementation

function TQueue.Pop;
var
p:pointer;
begin
  p:=inherited Pop;
  if head=nil then
    tail:=nil;
  if Assigned(onTaskComplete) then
  OnTaskComplete(p);
  result:=p;
end;

constructor TQueue.Create;
begin
  tail:=nil;
  inherited Create;
end;

procedure Tqueue.Push(data:Pointer);
begin
  if tail=nil then
    begin
       New(head);
       New(head^.data);
       head^.data:=data;
       head^.next:=nil;
       tail:=head;
    end else
      begin
       New(tail^.next);
       tail:=tail^.next;
       New(tail^.data);
       tail^.data:=data;
       tail^.next:=nil;
      end;
    inc(sizeval);
end;

procedure TQueue.AddString(s: string);
begin
   if tail=nil then
    begin
       New(head);
       head^.data:=PChar(s);
       head^.next:=nil;
       tail:=head;
    end else
      begin
       New(tail^.next);
       tail:=tail^.next;
       tail^.data:=PChar(s);
       tail^.next:=nil;
      end;
end;

end.
