unit stack;

interface


type
PStackRecord=^TStackRecord;
TStackRecord=record
data:Pointer;
next:PStackRecord;
end;

TStack=class
public
  datatype:integer;
  constructor Create;
  destructor Destroy;
  procedure Push(data:Pointer);
  function Pop():POinter;
  function Size:integer;
  function Last:Pointer;
  procedure PrintLast;
protected
  head:PStackRecord;
  sizevaL:integer;
end;

implementation
uses dialogs;
constructor TStack.Create;
begin
  head:=nil;
  sizEval:=0;
end;

destructor TStack.Destroy;
var
cur,t:PStackRecord;
begin
if head<>nil then
begin
cur:=head;
  while cur^.next<>nil do
    begin
    Dispose(cur^.data);
    t:=cur^.next;
    Dispose(cur);
    cur:=t;
    end;
end;
end;

procedure TStack.Push(data:Pointer);
begin
  if head=nil then
    begin
    New(head);
    New(head.data);
    head.data:=data;
    head.next:=nil;
    end else
      begin
      New(head^.next);
      head:=head^.next;
      New(head.data);
      head.data:=data;
      head.next:=nil;
      end;
    inc(sizeval);
end;

function TStack.Pop:pointer;
var
p:PStackRecord;
begin
if head<>nil then
begin
  result:=head^.data;
  p:=head^.next;
  Dispose(head);
  head:=p;
end else result:=nil;
dec(sizeval);
end;

function TStack.Size;
begin
result:=sizeval;
end;


function TStack.Last:POinter;
begin
  result:=head^.data;
end;

procedure TStack.PrintLast;
begin
  showmessage(string(last));
end;
end.
