unit LBClipping;

interface


function LB_tclip (p, q:real):integer;
function V_LBclip (var x0, y0, x1, y1:real):integer;

var
LB_t0, LB_t1:real;
Wxlef,   //*     */
Wybot,   //*     */
Wxrig,   //*                    */
Wytop:real;


implementation




function LB_tclip (p, q:real):integer;
var
accept:integer;
r:real;
begin
   accept:= 1;                           //*   */
   if (p = 0) then begin
      if (q < 0)then accept:= 0;             //*  */
   end else begin
      r:= q/p;
      if (p < 0) then begin
         if (r > LB_t1) then accept:= 0      //*  */
         else if (r > LB_t0) then LB_t0:= r;
      end else  begin
         if (r < LB_t0) then accept:= 0      //*  */
         else if (r < LB_t1) then LB_t1:= r;
      end;
   end;
   result:=accept;
end;  //* LB_tclip */










function V_LBclip (var x0, y0, x1, y1:real):integer;
var
visible:integer;
dx,dy:real;
begin
   visible:= 0;
   LB_t0:= 0;  LB_t1:= 1;
   dx:= x1 - x0;
   if (LB_tclip (-dx, x0-Wxlef))>0 then begin
      if (LB_tclip (dx, Wxrig-x0))>0 then begin
         dy:= y1 - y0;
         if (LB_tclip (-dy, y0-Wybot))>0 then begin
            if (LB_tclip (dy, Wytop-y0))>0 then begin
               if (LB_t1 < 1) then begin
                  x1:= x0 + LB_t1*dx;
                  y1:= y0 + LB_t1*dy;
               end;
               if (LB_t0 > 0) then begin
                  x0:= x0 + LB_t0*dx;
                  y0:= y0 + LB_t0*dy;
               end;
               inc(visible);
            end;
         end;
      end;
   end;
   result:=visible;
end;  //* V_LBclip */




end.
