unit gmGlobal;

interface
uses queue,gmUI;

var
 cursor:word;

page:integer;
pages:array[0..4]of integer;
gmTop_Items:array[0..4] of Word;
space:integer;

btnclicksnd:integer;

needinit:boolean = true;

barrackqueue:TQueue;//  

type
PBoxVill=^TBoxVill;
TBoxVill=record
  name:PChar;
  playername:PChar;
end;
TMapBox=record
  sprite:integer;
  data:Pointer;
//  data:TVillBox;
//  data:Pointer;
end;
TMapData=array[-250..250,-250..250]of TMapBox;


const

WOOD=1;
CLAY=2;
STONE=3;
FOOD=4;
POPS=5;

PAGE_DIALOG=7;
PAGE_VILL=1;
PAGE_CITY=2;
PAGE_MAP=3;
PAGE_STAT=4;
PAGE_INFO=5;
PAGE_MAIL=6;

MAX_BUILDINGS=27;


WALL=-2;// 
RALLY=-1;//

BUILDPLACE=101;

MAINBUILDING=6;
WAREHOUSE=1;
GRANARY=2;
BLACKSMITH=3;
ARMOURY=4;
TOURNAMENT_SQR=5;
MAIN=6;
GREAT_STABLE=7;
MARKETPLACE=8;
EMBASSY=9;
BARRACKS=10;
STABLE=11;
WORKSHOP=12;
ACADEMY=13;
CRANNY=14;
TOWNHALL=15;
RESIDENCE=16;
PALACE=17;
TREASURE_CHAMBER=18;
TRADE_OFFICE=19;
WOOD_MILL=20;
CLAY_MILL=21;
IRON_MILL=22;
CROP_MILL=23;
BAKERY=24;
GREAT_BARRACKS=25;




NAMES:array[-2..MAX_BUILDINGS] of PChar=
('Wall','Rally','Building place:','Warehouse','Granary','Blacksmith',
'Armoury','Tournament square',
'Main building','Great stable','Marcetplace','Embassy','Barracks','Stable',
'Workshop','Academy','Cranny','Town hall','Residence','Palace','Treasure chamber',
'Trade office','Sawmill','Brickyard','Iron foundry','Flour mill',
'Bakery','Great Barracks','Brewery','Stonemason');

INFO:array[-2..MAX_BUILDINGS] of PCHAR=
('A citywall can be built around a city. Building it will improve the defense of all units within the city from attacks',
'The rally point is the location where the troops are kept track of. A player can send troops, see the overview, or use the combat simulator from this building.',
'Here you can create new building for resources',
'The warehouse is the building in which wood, clay, and iron is stored. Upgrades'+
        ' to the warehouse allows more wood, clay, and iron to be stored. And '+
        'when your warehouse reaches level 20 you can build additional warehouses.',
'The granary is the building in which crop is stored. Upgrades to the granary '+
        'allows more crop to be stored. A level 3 granary (and level 5 crop field)'+
        ' is required for building a flour mill. And when your granary reaches'+
        ' level 20 you can build additional granaries.',
'The Blacksmith is the building in which you can upgrade your troops'' offense.',
'The armoury is the building in which you can upgrade your troop''s defense.',
'At the Tournament square your troops can train their stamina. The farther the '+
        'building is upgraded the faster are your troops beyond a minimum distance'+
        ' of 20 squares. Each level gives more speed to your units.',
'The main building is the first building that one sees when starting a new village.'+
        ' It is located just above the village center and is described as the place'+
        ' in your village where the master builders live.Upgrades to the main building'+
        ' increase the speed at which other buildings and resource fields are raised.'+
        ' Many buildings depend on the main building being a certain level.',
'The Great stable allows you to build more units in the same time but they cost'+
        ' thrice the original amount.',
'A marketplace will allow you to trade goods. You can send a merchant, with goods'+
        ' to another village to give that player goods, but the merchant will'+
        ' not return with any of his goods. If he wishes to send you goods,'+
        ' he must have his own merchant send goods. Every time you upgrade your'+
        ' marketplace you get another salesman.',
'In order to form an alliance you and the person you wish to form an'+
        ' alliance with must build an embassy.',
'The barracks is the building in which new troops are created.Upgrades to '+
        'the barracks speeds up the rate at which new troops are made. Each'+
        ' successive level cumulatively reduces the training time of units by 10%',
'The stable is the building in which new cavalry is created.Upgrades to'+
        ' the stable speeds up the rate at which new cavalry is trained.'+
        ' Each successive level cumulatively reduces the training time of units by 10%.',
'In the workshop rams and catapults (artillery) can be built. The higher its'+
        ' level the faster the production is completed. Each successive level'+
        ' cumulatively reduces the training time of units by 10%.',
'The Academy is the building in which new troops can be developed',
'The cranny is used to hide resources from attacking armies that would otherwise'+
        ' steal them. It is an essential part of the defensive strategy for a player'+
        ' to upgrade a cranny to minimize the amount of resources taken and make'+
        ' themselves a less appealing target for raiding.',
'The Town Hall (aka City Hall) is a cultural center for your village. In it you'+
        ' can organize festivities, and these celebrations will increase the number'+
        ' of your culture points, depending on the size of the party.',
'The residence is a small palace where the king lives if he visits the village.'+
        ' As long as there is a residence or a palace in the village, the village'+
        ' cannot be conquered until the building is destroyed by artillery.',
'The palace can be only built in one village, which is then your capital and so'+
        ' protected against any enemy who tries to conquer it as long as you have less than four villages.',
'There are villages discovered of the Nataren tribe. These villages have unique '+
        'Artifacts that can enhance certain things for you if you have them in your Treasure chamber.',
'In the Trade Office you can upgrade your merchant''s carts and improve them with'+
        ' better horses. The further you upgrade this building the more resources will your merchants be able to carry.',
'The Sawmill is an add on to your wood production. At level 1 it adds 5%, and at'+
        ' the subsequent levels it adds 5 more for a total of 25%. ',
'The Brickyard is an add on to your clay production. At level 1 it adds 5%, and'+
        ' at the subsequent levels it adds 5 more for a total of 25%.',
'The Iron Foundry is an add on to your iron production. At level 1 it adds 5%,'+
        ' and at the subsequent levels it adds 5 more for a total of 25%.',
'The Flour Mill is an add on to your crop production. At level 1 it adds 5%,'+
        ' and at the subsequent levels it adds 5 more for a total of 25%.',
'The Bakery is an add on to your crop production. At level 1 it adds 5%, and at'+
        ' the subsequent levels it adds 5 more for a total of 25%.',
'The Great barrack allows you to build more units in the same time but they cost'+
        ' thrice the original amount. While it does not actually produce more units,'+
        ' it provides one a second way to produce units in parallel, albeit at markedly'+
        ' higher costs. Upgrades to the Great barrack speeds up the rate at which'+
        ' new troops are made..',
'?','?');

type
PTrainUnitRecord=^TTrainUnitRecord;
TTrainUnitRecord=record
num,time,unittype:integer;
end;

TBuildProgress=record
time:integer;
building:integer;
lvl:integer;
place:integer;
end;

PXYCoord=^TXYCoord;
TXYCoord=record
X,Y:integer;
name:string;
end;

TBuilding=record
index:integer;
level:integer;
end;

TCityData=record
buildprogress:TBuildProgress;
constructing:boolean;
buildings:array[1..21]of TBuilding;
end;

TVillData=record
buildprogress:TBuildProgress;
constructing:boolean;
pits:array[1..18]of TBuilding;
PitType:array[1..18] of word;
end;

TArmyData=record
troops:array[1..10]of integer;
troopslvls:array[1..10]of integer;
end;

TMoving=record
troops:array[1..10]of integer;
troopslvls:array[1..10]of integer;
target:TXYCoord;
time:integer;
end;

TVillage=record
vill:TVillData;
city:TCityData;
pop:integer;
army:TArmyData;
moving:TMoving;
x,y:integer;
name:string[255];
end;

TPlayerData=record
login,pass:string[100];
vils:array of TVillage;
res:array[1..4]of real;
end;

TGameData=record
players:array of TPlayerData;
map:array[-255..255,-255..255]of word;
end;

var
gamedata:TPlayerData;
game:TGameData;
ResourceSprites:array[1..5]of word;
SmallRes:array[1..5]of word;
BigRes:array[0..5]of word;

const
TOPMENUHEIGHT=64;

procedure gmInitTop;
procedure gmDrawTop;
procedure gmDeInitTop;

function ecSpendResources(a,b,c,d:integer):boolean;
function ecGetUpgradeCosts(building,resource:integer):integer;overload;
function ecGetUpgradeCosts(building:string;level,resource:integer):integer;overload;

procedure gmNewGame;

implementation
uses ueTypes,ueMain,gmMain,kol,
gmMap,gmCity,gmVillage,gmTimeCalc,gmAI;

procedure gmMapOnCityBTnDraw(id:word;x,y:integer;width,height:word);
begin
  ueRenderSprite(x,y,width,height,citysprite,255);
  if gmUIIsMouseOver(id) then
    ueRenderRectangle(x,y,width,height,255,128,128,255,false);
end;

function ecSpendResources(a,b,c,d:integer):boolean;
begin
if (gamedata.res[1]>a)and
   (gamedata.res[2]>b)and
   (gamedata.res[3]>c)and
   (gamedata.res[4]>d)then
   begin
   gamedata.res[1]:=gamedata.res[1]-a;
   gamedata.res[2]:=gamedata.res[2]-b;
   gamedata.res[3]:=gamedata.res[3]-c;
   gamedata.res[4]:=gamedata.res[4]-d;
   result:=true;
   end else result:=false;
end;

procedure gmTopOnBtnClick(id:word);
begin
//
ueSndPlay(btnclicksnd,false,50);
case page of
        PAGE_CITY:gmCityDeInit;
        PAGE_MAP: gmMapDeInit;
        PAGE_VILL:gmVillageDeInit;
end;
if id=gmTop_Items[PAGE_CITY-1]
 then   begin
        gmCityRun;
        page:=PAGE_CITY;
        end;
if id=gmTop_Items[PAGE_MAP-1]
 then   begin
        gmMapRun;
        page:=PAGE_MAP;
        end;
 if id=gmTop_Items[PAGE_VILL-1]
 then   begin
        gmVillageRun;
        page:=PAGE_VILL;
        end;

end;

procedure gmNewGame;
var
i:integer;
begin
    for i:=1 to 4 do
    begin
    gamedata.res[i]:=12000;
    MyResourcesProd[i]:=8;
    end;
SetLength(game.players,1);
game.players[0]:=gamedata;//    .
for i := 1 to 10000 do  
  aiNewComputer;
barrackqueue:=Tqueue.Create;
end;


procedure gmTopOnDrawButton(Id:word;X,Y:integer;Width,Height:word);
var
  i:byte;
  curSpriteID:word;
begin
for i:=0 to 4 do
if id=gmTop_Items[i] then
begin
        curSpriteID:=pages[i];
        break;
end;
        ueRenderSprite(X,Y,64,64,
        curSpriteId,200);
end;




procedure gmDrawTop;
begin
ueRenderSprite(0,gmMain_height-64,20,64,
        space,200);
ueRenderSprite(84,gmMain_height-64,16,64,
        space,200);
ueRenderSprite(164,gmMain_height-64,16,64,
        space,200);
ueRenderSprite(244,gmMain_height-64,16,64,
        space,200);
ueRenderSprite(324,gmMain_height-64,16,64,
        space,200);
ueRenderSprite(404,gmMain_height-64,gmMain_width,64,
        space,200);

game.players[0]:=gamedata;//    .
end;

function EcGetUpgradeCosts(building,resource:integer):integer;
begin
if costdb.FindField(NAMES[building],LEVELS[building]) then
  result:=costdb[resource] else result:=-1;
end;

function EcGetUpgradeCosts(building:string;level,resource:integer):integer;
begin
if costdb.FindField(building,level) then
  result:=costdb[resource] else result:=-1;
end;

procedure gmInitTop;
var
i:integer;
begin

if needinit then 
begin
 space:=ueRenderAddSprite('space');

 btnclicksnd:=ueSndAdd('click2.wav');

 gmTop_Items[0]:=gmUINewButton(20,gmMain_Height-64,
    64,64,gmTopOnDrawButton,gmTopOnBtnClick);

 gmTop_Items[1]:=gmUINewButton(100,gmMain_Height-64,
    64,64,gmTopOnDrawButton,gmTopOnBtnClick);

 gmTop_Items[2]:=gmUINewButton(180,gmMain_Height-64,
    64,64,gmTopOnDrawButton,gmTopOnBtnClick);

 gmTop_Items[3]:=gmUINewButton(260,gmMain_Height-64,
    64,64,gmTopOnDrawButton,nil);

 gmTop_Items[4]:=gmUINewButton(340,gmMain_Height-64,
    64,64,gmTopOnDrawButton,nil);

 pages[0]:=ueRenderAddSprite('Page_1');
 pages[1]:=ueRenderAddSprite('Page_2');
 pages[2]:=ueRenderAddSprite('Page_3');
 pages[3]:=ueRenderAddSprite('Page_4');
 pages[4]:=ueRenderAddSprite('Page_5');

 for i:=1 to 5 do
 begin
 resourcesprites[i]:=ueRenderAddSprite(PChar('res'+int2str(i)));
 SmallRes[i]:=ueRenderAddSprite(PChar('smallres'+int2str(i)));
 BigRes[i]:=ueRenderAddSprite(PChar('bigres'+int2str(i)));
 end;
  BigRes[0]:=ueRenderAddSprite('bigres0');

 needinit:=false;

 for i:=1 to 5 do
  citybtns[i]:=gmUINewButton(20+i*50,30,32,32,gmMapOnCityBTnDraw,nil);
 //CreateHelpForm;
 end;

end;

procedure gmDeInitTop;
var
i:integer;
begin
for i:=0 to Length(gmTop_Items)-1 do
  gmUIDelete(gmTop_Items[i]);
for i:=1 to 5 do
  gmUiDelete(citybtns[i]);
end;


end.

