{
    
}
unit gmMenu;

interface
uses gmUI;

procedure gmMenuInit;
procedure gmMenuRun;

//-----------------------------------------------------------
var
sndBackGround:integer;
//------------------------------------------------------------

implementation

uses
  Windows,classes,
  ueTypes,
  ueMain,gmTimeCalc,
//  gmUI,
  gmCity,gmMap,gmVillage,
  gmMain,
  gmGlobal,
  frmHelpform;

const
  gmMenu_MaxItems = 5;

var
  gmMenu_Items:array[0..gmMenu_MaxItems-1] of word;
  gmMenu_Background:word;
  gmMenuSprites:array[0..1] of word;
  form,about:TUIForm;




procedure gmMenuInit;
var
i:integer;
begin
sndBackground:=ueSndAdd('lemuria.mp3');
  //ueSndSetMusic(sndBackground,true);
  i:=ueSndPlay(sndbackground,true,255);
end;


//--------------Dialogs-------------------------------------------------

procedure OnExitClick(id:word);
begin
if assigned(about) then
        about.destroy;
about:=nil;
end;

//----------------------------------------------------------------------

procedure gmMenuOnMouseOver(id:word;X,y:Integer);
begin
gmUISetFocus(id);
end;

procedure gmMenuDeInit;
var
i:integer;
begin
for i:=0 to 4 do
gmUIDelete(gmMenu_Items[i]);
form.Destroy;
end;


procedure gmMenuOnDrawButton(Id:word;X,Y:integer;Width,Height:word);
var
  str:string;
  len:word;
  i:byte;
begin
  str:=gmUIGetText(id);
  len:=ueRenderTextLength(PChar(str));

  if gmUIIsFocused(id) then
    begin
      for i:=0 to 2 do
        ueRenderSprite(X+i*64,Y,64,32,
          gmMenuSprites[0],255);
    end
  else
    begin
      for i:=0 to 2 do
        ueRenderSprite(X+i*64,Y,64,32,
          gmMenuSprites[1],255);
    end;
  ueRenderTextEx(X+(width-len*16)div 2,Y+8,
    gmMain_Font,PChar(str),16,32,
    0,0,0,255);
end;

procedure gmMenuOnChangeFocus(Id:word);
var
  i:byte;
begin

  for i:=0 to gmMenu_MaxItems-1 do
    if id = gmMenu_Items[i] then
      begin
        if i<>gmMenu_MaxItems-1 then
          gmUISetFocus(gmMenu_Items[i+1])
        else
          gmUISetFocus(gmMenu_Items[0]);
        exit;
      end;
end;

procedure gmMenuOnChangeFocusEx;
var
  i:byte;
  id:word;
begin

  id:=gmUIGetFocus;
  for i:=0 to gmMenu_MaxItems-1 do
    if id = gmMenu_Items[i] then
      begin
        if i<>0 then
          gmUISetFocus(gmMenu_Items[i-1])
        else
          gmUISetFocus(gmMenu_Items[gmMenu_MaxItems-1]);
        exit;
      end;
end;

procedure gmMenuKeyDown(Key:integer);
begin
  case Key of
    VK_UP:
      begin
        gmMenuOnChangeFocusEx;
      end;
    VK_DOWN:
      begin
        gmMenuOnChangeFocus(gmUIGetFocus);
      end;
  end;
end;

procedure gmMenuOnQuit(Id:word);
begin
if gmUIIsFocused(id) then begin
        mainShutDownGame;
  end;
end;


procedure gmMenuOnNew(id:word);
begin
OnExitClick(0);
if gmUIIsFocused(id) then
begin
  ueSndStop(sndBackground);
  sndBackground:=ueSndAdd('sound.mp3');
  ueSndPlay(sndBackground,true,100);

  page:=PAGE_CITY;
  CreateHelpForm;
  gmInitTop;
  gmMapInit;
  gmVillageInit;
  gmCityInit;
  gmNewGame;
  gmMenuDeInit;
  gmCityRun;

//        ueRender2d;
//        ForceIdle;
end;
end;

procedure gmMenuOnAbout(id:word);
begin
if gmUIIsFocused(id) then
        if not assigned(About)then
        about:=TUIForm.Create('about.frm');
        about['exit'].OnPress:=OnExitClick;

end;

procedure gmMenuInitEx;

begin
  gmMenu_Background:=ueRenderAddSprite('BackGround');
  gmMenuSprites[0]:=ueRenderAddSprite('item1');
  gmMenuSprites[1]:=ueRenderAddSprite('item2');
  cursor:=ueRenderAddSprite('MenuCursor');

//form['Pn'].visible:=false;
//  gmUINewLabel(gmMain_Width-250,20,20,'LeoSOFT 2006',255,0,0,255);
//  gmUiNewWindow(100,100,300,100,128,128,100,200,'Hello,world');

  form:=TUIForm.Create('form.frm');
  form.border:=false;
  form['panel1'].A:=150;

  gmMenu_Items[0]:=gmUINewButton(60,gmMain_Height-60,
    200,32,gmMenuOnDrawButton,gmMenuOnNew,gmMenuOnMouseOver);
  gmUISetText(gmMenu_Items[0],'N^0ew Game');

  gmMenu_Items[1]:=gmUINewButton(60,gmMain_Height-120,
    200,32,gmMenuOnDrawButton,nil,gmMenuOnMouseOver);
  gmUISetText(gmMenu_Items[1],'L^0oad Game');

  gmMenu_Items[2]:=gmUINewButton(60,gmMain_Height-180,
    200,32,gmMenuOnDrawButton,nil,gmMenuOnMouseOver);
  gmUISetText(gmMenu_Items[2],'L^0an Game');

  gmMenu_Items[3]:=gmUINewButton(60,gmMain_Height-240,
    200,32,gmMenuOnDrawButton,GmMenuOnAbout,gmMenuOnMouseOver);
  gmUISetText(gmMenu_Items[3],'A^0bout');

  gmMenu_Items[4]:=gmUINewButton(60,20,
    200,32,gmMenuOnDrawButton,gmMenuOnQuit,gmMenuOnMouseOver);
  gmUISetText(gmMenu_Items[4],'Q^0uit');

  gmUISetFocus(gmMenu_Items[0]);

  gmUI_OnChangeFocus:=gmMenuOnChangeFocus;
  gmMenu_OnKeyDown:=gmMenuKeyDown;

end;

procedure gmMenuIdle;
begin
  ueRenderSprite(0,0,
    gmMain_Width,gmMain_Height,
    gmMenu_Background,
    255);

  gmUIDraw;
  tmReCalcStack;

  ueREnderSprite(gmMain_CursorX-8,gmMain_CursorY-8,16,16,
    cursor,250);
end;



procedure gmMenuRun;
begin
  gmMenuInitEx;
  SetOnIdle(gmMenuIdle);
end;



end.
