{
UI Controls version 0.0000000000000000000000000000001 Alpha :D
}
unit gmUI;

interface
uses kol;

const
ueFnt_StandartText =
    'zxcvbnmasdfghjkl;:'',."/][poiuytrewq<>?!@#$%^&*()_'+
    ''+
    'ڨ'+
    'ZXCVBNMASDFGHJKLPOIUYTREWQ1234567890-=\|+';

type
  MyPoint=record
  X,Y:integer;
  end;
  PPointArr=array[0..0] of MyPoint;
  TUIOnDraw = procedure(Id:word;X,Y:integer;Width,Height:word);
  TUIOnChar = procedure(Id:word;Char:char);
  TUIOnKeyDown = procedure(Id:word;Key:integer);
  TUIOnKeyUp = TUIOnKeyDown;
  TUIOnMouseMove = procedure(Id:word;X,Y:integer);
  TUIOnMouseKeyDown = procedure(Id:word;X,Y:integer;Left,Right:boolean);
  TUIOnMouseKeyUp = TUIOnMouseKeyDown;
  TUIOnChangeFocus = procedure(Id:word);
  TUIOnChangeCaption  = procedure(Id:word);
  TUIOnPress = procedure(Id:word);

    TModalStatus=(
        M_NONE,
        M_OK,
        M_CANCEL,
        M_RETRY,
        M_EXIT,
        M_RUNNING
  );
  const
  APPLICATION=0;
  FORM=1;
  STATICFORM=2;
  DIALOG=3;
  NONE=4;



var
  gmUI_OnChangeFocus:TUIOnChangeFocus;
  gmUI_CursorX,gmUI_CursorY:integer;
  MainSmallFont,  ConsoleFont,  Mainfont:word;
  gmUI_Focus:integer = -1;
  gmUI_Modal:TModalStatus;
  gmUI_Status:word;
  gmUI_Over:integer=-1;

  Arial10,Arial15,Arial20,Corier10,Corier15,BlackAdder30,BlackAdder15,BankGothic30:byte;


procedure gmUISetOnPress(id:word;proc:TUIOnPress);

procedure OnImageDraw(id:word;x,y:integer;width,height:word);
procedure OnPanelDraw(Id:word;X,Y:integer;Width,Height:word);
procedure OnProgressDraw(id:word;x,y:integer;width,height:word);

procedure gmUIOnChar(id:word;Char:char);
procedure gmUIOnKeyDown(Key:integer);
procedure gmUIOnKeyUp(Key:integer);
procedure gmUIOnMouseKeyDown(X,Y:integer;Left,Right:boolean);
procedure gmUIOnMouseKeyUp(X,Y:integer;Left,Right:boolean);
procedure gmUIOnMouseMove(X,Y:integer);

procedure gmUIInit;
procedure gmUIDeInit;

procedure gmUIDraw;
procedure gmUISetFocus(Id:word);

function gmUIGetValue(id:word;field:string):Variant;
procedure gmUISetValue(id:word;field:string;value:Variant);
procedure gmUISetVisible(id:word;val:boolean);

function gmUIAdd:word;
procedure gmUIDelete(Id:word);



function gmUINewWindow(X,Y:integer;width,height:word;R,G,B,A:integer;caption:string;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
function gmUINewImage(X,Y:integer;width,height:word;sprite:string;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
function gmUINewLabel(X,Y:integer;size:word;caption:string;R,G,B,A:integer;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
function gmUINewPanel(X,Y:integer;width,height:word;R,G,B,A:integer;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
function gmUINewInputBox(X,Y:integer;Width,Height:word;
  OnDraw:TUIOnDraw;OnChangeCaption:TUIOnChangeCaption):word;
function gmUINewInputBoxEx(X,Y:integer;Width,Height:word;
  OnDraw:TUIOnDraw;OnChar:TUIOnChar):word;
function gmUINewButton(X,Y:integer;Width,Height:word;
  OnDraw:TUIOnDraw;OnPress:TUIOnPress;OnMouseMove:TUIOnMouseMove=nil):word;
function gmUINewButtonEx(vertex:Pointer;OnDraw:TUIOnDraw;OnPress:TUIOnPress;OnMouseMove:TUIOnMouseMove=nil):word;

function gmUIGetText(Id:word):string;
procedure gmUISetText(Id:word;const Text:string);
procedure  gmUISetParent(id:word;parent:word);
procedure gmUISetXY(Id:word;x:integer=-1;y:integer=-1);
function gmUIGetY(id:word):integer;
function gmUIGetX(id:word):integer;

function IsInside( a:array of MyPoint; b:MyPoint):boolean;

function gmUIIsFocused(Id:word):boolean;
function gmUIIsPressed(id:word):boolean;
function gmUIIsMouseOver(id:Word):boolean;
function gmUIGetFocus:word;

procedure DrawProgressBar(x,y,width,height:integer;progress:integer);

procedure ueRenderFontBox(font:byte;text:PCHar;x,y:integer;width,height,size:integer;R,G,B,A:byte);

type
  PUI = ^TUI;


  TUIOnCharEx = procedure(Id:word;Item:PUI;Char:char);

  TUIType = (
    UI_INPUT_MANUAL,
    UI_INPUT_AUTO,
    UI_BUTTON,
    UI_BUTTON_EX,
    UI_PANEL,
    UI_IMAGE,
    UI_LABEL,
    UI_BIGLABEL, //In devolopment...Use ueRenderFontBox
    UI_CHECKBOX,
    UI_RADIOBOX,  //Not working yet...
    UI_PROGRESS,  //
    UI_WINDOW,
    UI_NONE
    );


  TUIField=record
  name:string;
  value:Variant;
  end;
  TUI = record
    UIType:TUIType;
    X,Y:integer;
    Width,Height:word;
    parent:word;
    ID:integer;
    name:string[10];
    R,G,B,A:integer;
    TEMP:INTEGER;
    DATA:INTEGER;
    fields:array[1..10]of TUiField;
    fieldcount:integer;
    Caption:Widestring;
    Result:TModalStatus;
    over,pressed:boolean;
    visible:boolean;
    adata:Pointer;
    OnDraw:TUIOnDraw;//INPUT,BUTTON,WINDOW (PANEL?)
    OnChar:TUIOnChar;     //INPUT,WINDOW
    OnCharEx:TUIOnCharEx;        //INPUT
    OnKeyDown:TUIOnKeyDown; //INPUT
    OnKeyUp:TUIOnKeyUp; //INPUT
    OnMouseKeyDown:TUIOnMouseKeyDown; //ALL
    OnMouseKeyUp:TUIOnMouseKeyUp;//ALL
    OnMouseMove:TUIOnMouseMove;//ALL
    OnMouseOver:TUIOnMouseMove;//ALL
    OnChangeCaption:TUIOnChangeCaption;//INPUT
    OnPress:TUIOnPress;//BUTTON
    end;



TUiForm=class
controls:array of integer;
visibleval,borderval:boolean;
empty:boolean;
x,y,width,height:integer;
handle:word;
modalstyle,oldstyle:word;
result:integer;
procedure Init;
procedure Load(path:string);
procedure SetXY(NewX,NewY:Integer);
function AddControl(name:string):word;
function SetOnPress(name:string;Proc:TUIOnPress):boolean;
function SetOnMouseMove(name:string;Proc:TUIOnMouseMove):boolean;
function SetOnChar(name:string;Proc:TUIOnChar):boolean;
function SetOnDraw(name:string;Proc:TUIOnDraw):boolean;
procedure SetBorder(val:boolean);
function GetItem(index:string):PUI;
procedure SetVisible(val:boolean);
property items[index:string]:PUI read GetItem;default;
property visible:boolean read visibleval write SetVisible;
property border:boolean read borderval write SetBorder;
constructor Create(path:string);
destructor Destroy;
end;

PUiForm=^TUiForm;

const
WINDOWSprite=1;
BUTTONSprite=2;
BUTTONOverSprite=3;
CheckBoxSprite=4;
CheckBoxOverSprite=5;
CheckBox2Sprite=6;
CheckBoxOver2Sprite=7;
EditSprite=8;
EditOverSprite=9;

MAXUISPRITE=9;

implementation

uses
  Windows,ueTypes,ueMain;

var
  sprites:array[1..MAXUISPRITE]of word;
  gmUI_Count:word;
  gmUI_Items:array of PUI;

procedure DrawProgressBar(x,y,width,height:integer;progress:integer);
begin
   ueRenderRectangle(x,y,width,height,0,0,0,100,false);
   ueRenderRectangle(x+2,y+2,width-3,height-3,0,0,0,50,true);
   if round(int(width*progress/100)-2)>0 then
     ueRenderRectangle(x+4,y+4,round(int(width*progress/100)-2),height-5,0,0,0,250,true);
end;

procedure OnProgressDraw(id:word;x,y:integer;width,height:word);
var
cur:PUI;
perc,R,G,B:integer;
begin
        cur:=gmUI_Items[id];
        ueRenderRectangle(x,y,width,height,0,0,0,100,false);
        ueRenderRectangle(x+2,y+2,width-3,height-3,0,0,0,50,true);
        perc:=gmUI_Items[id].DATA;
        r:=gmUI_Items[id].r;g:=gmUI_Items[id].g;b:=gmUI_Items[id].b;
        ueRenderFontText( arial10,gmUIGetText(id),x+10,y+5,r,g,b,128);
        if round(int(width*perc/100)-2)>0 then
        ueRenderRectangle(x+4,y+4,round(int(width*perc/100)-2),height-5,R,G,B,250,true);
end;


procedure OnPanelDraw(Id:word;X,Y:integer;Width,Height:word);
var
cur:PUI;
begin
cur:=gmUI_Items[id];
with cur^ do begin
        ueRenderRectangle(x,y,width,height,0,0,0,100,false);
        ueRenderRectangle(x+2,y+2,width-3,height-3,0,0,0,100,true);
        end;
end;

procedure OnBigLabelDraw(Id:word;X,Y:integer;Width,Height:word);
var
curstring:string;
caption:WideString;
cur:integer;
begin
caption:=gmUI_Items[id].caption;
for cur:=1 to Length(Caption) do
begin
        curstring:=curstring+caption[cur];
        end;
end;

procedure OnEditFocus(Id:word{;X,Y:integer;Left,Right:boolean});
begin
gmUIsetFocus(id);
end;

procedure OnEditDraw(Id:word;X,Y:integer;Width,Height:word);
var
alttext:string;
begin
if (id=gmUI_Focus) then
begin
ueRenderSprite(x,y,width,height,sprites[EditOverSprite],255);
        if (GetTickCount mod 2)=0 then
        ueRenderRectangle(X+width-15,y+height div 6,5,height div 3*2,250,128,128,180,true);
end else
        if(gmUI_Items[id].over)then
        ueRenderSprite(x,y,width,height,sprites[EditOverSprite],255) else
                ueRenderSprite(x,y,width,height,sprites[EditSprite],255);;

ueRenderFontTextEx(corier15,gmUI_Items[id].caption,x+5,y+5,0,0,255,255,width div 10-1);
alttext:=gmUIGetValue(id,'alttext');
if alttext<>'$$NO FIELD$$' then
ueRenderFontTextEx(corier15,alttext,x+5,y+5,180,180,180,128,width div 10-1);
  {ueRenderFontTextEx(
    0,
    PChar(gmUI_Items[id].caption),
    x+1,
    y+1,
    width
    gmUI_Items[id].R,gmUI_Items[id].G,gmUI_Items[id].B,gmUI_Items[id].A,
    );}
end;

procedure OnWindowDraw(Id:word;X,Y:integer;Width,Height:word);
var
cur:PUI;
begin
cur:=gmUI_Items[id];
with cur^ do begin
        if cur.TEMP=0 then// .
                begin
                ueRenderSprite(x-40,y,width+43,height,sprites[WINDOWSprite],255);
                ueRenderFontTextEx(blackadder30,(caption),x,y+height,200,0,0,200,width);
                end else
                    begin// .    
//                    ueRenderRectangle(x,y,width,height,0,0,0,100,false);
//                    ueRenderRectangle(x+2,y+2,width-3,height-3,0,0,0,50,true);
                    end;

        end;
end;


procedure OnLabelDraw(id:word;X,Y:integer;width,height:word);
var
fnt:word;
begin
if height>20 then fnt:=arial20 else
   if (height<20)and(height>=15)then fnt:=arial15 else
      fnt:=arial10;
//ueRenderTextEx(x,y,mainFont,PCHar(gmUIGetText(id)),height,width div height,gmUI_Items[id].R,gmUI_Items[id].G,gmUI_Items[id].B,gmUI_Items[id].A);
  ueRenderFontTextEx(
    fnt,
    PChar(gmUIGetText(id)),
    x,
    y,
    gmUI_Items[id].R,gmUI_Items[id].G,gmUI_Items[id].B,gmUI_Items[id].A,
    width
    );
end;

procedure OnImageDraw(id:word;x,y:integer;width,height:word);
begin
ueRenderSprite(X,Y,WIDTH,HEIGHT,gmUI_Items[id].DATA,255);
end;

procedure OnButtonDraw(id:word;x,y:integer;width,height:word);
begin
//with gmUI_Items[id]^ do begin

//{if (id=gmUI_Focus) then

        if(gmUI_Items[id].over)then
        ueRenderSprite(x,y,width,height,sprites[BUTTONSprite],255) else
        ueRenderSprite(x,y,width,height,sprites[BUTTONOverSprite],255);


ueRenderFontTextEx(Blackadder30,(gmUI_Items[id].caption),x+3,y+1+height div 3,gmUI_Items[id].R,gmUI_Items[id].G,gmUI_Items[id].B,255,width div 10);
//ueRenderRectangle(x,y,width,height,255,0,0,0,false);
 { ueRenderFontText(
    1,
    PChar(gmUI_Items[id].caption),
    x+1,
    y+1+height div 3,
    0,255,0,255
    );}
end;



procedure OnCheckBoxDraw(id:word;x,y:integer;width,height:word);
begin
//lw:=glGetIntegerV(GL_LINE_WIDTH);
//glLineWidth(2);
if gmUI_Items[id].over then
begin
        if gmUI_Items[id].DATA=1 then
        ueRenderSprite(x,y,height,height,sprites[CheckBoxOver2Sprite],255)else
        ueRenderSprite(x,y,height,height,sprites[CheckBoxOverSprite],255);
end else
        begin
        if gmUI_Items[id].DATA=1 then
        ueRenderSprite(x,y,height,height,sprites[CheckBox2Sprite],255)else
        ueRenderSprite(x,y,height,height,sprites[CheckBoxSprite],255);
        end;
{if gmUI_Items[id].DATA=1 then
        ueRenderRectangle(x+2,y+2,height-4,height-4,200,200,200,255,true);}
ueRenderFontText(arial15,(gmUI_Items[id].Caption),x+height+5,y+10,255,0,0,255);
end;





//---
procedure gmUIOnCharEx(Id:word;Item:PUI;Char:char);
const
NUMERIC=1;
NORMAL=0;
begin
  //case Char of
  case Char of
    #8:{BackSpace}
      begin
       if Item.Caption<>'' then
          if Length(Item.Caption) = 1 then
            Item.Caption:=''
          else
            Item.Caption:=Copy(
              Item.Caption,1,Length(Item.Caption)-1);
        if Assigned(Item.OnChangeCaption) then
          Item.OnChangeCaption(Id);
      end;
    #9:{Tab}
      begin
        if Assigned(gmUI_OnChangeFocus) then
          gmUI_OnChangeFocus(Id);
      end;
    #13:{Enter}
      begin

      end;
    #96://  - 
      begin

      end;
    else
      begin
        if Length(item.caption)<item.width then
           if ((item.DATA=NUMERIC)and(char in ['0'..'9']))or(item.DAtA=NORMAL) then
                Item.Caption:=Item.Caption+Char;
       { if Assigned(Item.OnChar)then
          Item.OnChar(Id,Char);}
        if Assigned(Item.OnChangeCaption) then
          Item.OnChangeCaption(Id);
      end;
    end;
end;

procedure gmUIOnChar(id:word;Char:char);
var
  tmp:PUI;
begin
  if gmUI_Focus = -1 then
    exit;
  if gmUI_Focus>=Length(gmUI_Items) then
    exit;
  if Assigned(gmUI_Items[gmUI_Focus]) then
    begin
      tmp:=gmUI_Items[gmUI_Focus];

      if Assigned(tmp.OnCharEx)then
        tmp.OnCharEx(
          gmUI_Focus,
          tmp,
          Char)else
        if Assigned(tmp.OnChar)then
          tmp.OnChar(
            gmUI_Focus,
            Char)

    end;
end;


//---

procedure TUIForm.Init;
begin
SetLength(controls,0);
end;

procedure TUiForm.SetVisible(val:boolean);
var
i:integer;
begin
visibleval:=val;
for i:=0 to Length(controls)-1 do
        gmUI_Items[controls[i]].visible:=val;
if val then
        begin
        gmUI_Status:=modalstyle;
        end else
                begin
                gmUI_Status:=APPLICATION;
                end;
end;

procedure TUiForm.SetBorder(val:boolean);
begin
borderval:=val;
if val then
gmUI_Items[Handle].TEMP:=0 else
gmUI_Items[handle].temp:=1;
end;

procedure TUiForm.SetXY(NewX,NewY:integer);
var
i,dx,dy:integer;
begin
dx:=newx-x;
dy:=newy-y;
for i:=0 to Length(controls)-1 do
    begin
    inc(gmUI_Items[controls[i]].X,dx);
    inc(gmUI_Items[controls[i]].Y,dy);
    end;
x:=NewX;
y:=NewY;
end;

procedure TUIForm.Load(path:string);
const
STATE_INDEX=0;
STATE_OBJNAME=1;
STATE_OBJTYPE=2;
STATE_COMPONENTS=3;
STATE_FIELDVALUE=4;
var
ch:Char;// 
line:string;
word:string;// 
tmp:PUI;// 
index:integer;//
curObjectID:integer;//  
curObjectString:string;  //  
curField:string;           // -
curObjectType:TUiType;  //  ( , ,)
parentObjectString:string;//
parentObjectType:TUiType;// 
state:integer;//  
f:TextFile;// .( )
offx,offy:array of integer;// .   
//:      .
//     , ,     .
log:TextFile;// 
begin
//if empty then begin
{}
        SetLength(offx,1);
        SetLength(offy,1);
        offx[0]:=0;
        offy[0]:=0;
        assignFile(f,'./GUI/'+path);
        assignFile(log,'./GUILog.log');
        Rewrite(log);
        ch:=' ';word:='';state:=0;curObjectString:='';curObjectType:=UI_NONE;parentObjectString:='';curObjectID:=0;
        reset(f);
{  }
        while not eof(f) do//)))
                begin
                if state<>STATE_FIELDVALUE then
                read(f,ch) else
                        readln(f,line);//  
                if(ch<>' ')and(ch<>'=')and(ch<>':')and(ch<>#13) then//    
                        begin
                                if(ch<>#9)and(ch<>#10)and(ch<>#13)then//      
                                word:=word+ch;//    
                        end else
                                begin
                                if (word='object')and((state=STATE_INDEX)or(state=STATE_COMPONENTS))//       ,
                                        and((ch=#13)or(ch=#10)or(ch=' ')) then// - 
                                        begin
                                        inc(state);// 
                                        index:=gmUIAdd;//  ( )

                                        writeln(log,'object found index:'+int2str(index));//

                                        state:=STATE_OBJNAME;//  -   

                                        //     
                                        tmp:=gmUI_Items[index];
                                        tmp.parent:=modalstyle;
                                        tmp.OnDraw:=nil;
                                        tmp.OnChar:=nil;
                                        tmp.OnCharEx:=nil;
                                        tmp.OnKeyDown:=nil;
                                        tmp.OnKeyUp:=nil;
                                        tmp.OnMouseKeyDown:=nil;
                                        tmp.OnMouseKeyUp:=nil;
                                        tmp.OnMouseMove:=nil;
                                        tmp.OnMouseOver:=nil;
                                        tmp.OnPress:=nil;
                                        tmp.OnChangeCaption:=nil;
                                        tmp.visible:=true;
                                        tmp.ID:=index;

                                        SetLength(controls,Length(controls)+1);//  .
                                        controls[Length(controls)-1]:=index;// -
                                        word:='';//     .
                                        continue;//  
                                        end;

                                if (state=STATE_OBJNAME)and(ch=':') then  //       :,
                                        begin
                                        parentObjectString:=curObjectString;//   
//                                        parentObjectType:=curObjectType;
                                        curObjectString:=word;//   -  

                                        writeln(log,'object name:'+word);//

                                        inc(state);//. -   

                                        tmp.name:=curObjectString;//  


                                        word:='';// 
                                        continue;// 
                                        end;

                                if (state=STATE_OBJTYPE)and((ch=#13)or(ch=#10)or(ch=' ')) then//    
                                        begin
                                        inc(state);//. -     
                                        writeln(log,'object type:'+word);//
                                        parentObjectType:=curObjectType;//    

                                        if (word='button')then//  ,
                                                begin
                                                curObjectType:=UI_BUTTON;//   - 
                                                tmp.OnDraw:=OnButtonDraw;
                                                end;
                                        if(word='inputbox')then//    
                                                begin
                                                curObjectType:=UI_INPUT_AUTO;//  -  
                                                // 
                                                tmp.OnDraw:=OnEditDraw;
                                                tmp.OnPress:=onEditFocus;
                                                tmp.OnCharEx:=gmUIOnCharEx;
                                                tmp.fieldcount:=1;
                                                tmp.fields[1].name:='alttext';
                                                tmp.fields[1].value:='';
                                                tmp.DATA:=0;
//                                                tmp.OnChar:=gmUIOnChar;
                                                end;
                                        if(word='window')then//
                                                begin
                                                curObjectType:=UI_WINDOW;//   - 
                                                // . 
                                                handle:=index;
                                                tmp.TEMP:=0;
                                                tmp.OnDraw:=OnWindowDraw;
                                                end;
                                        if(word='panel')then       //
                                                begin
                                                curObjectType:=UI_PANEL;//   - 
                                                tmp.OnDraw:=OnPanelDraw;
                                                end;
                                        if word='label' then
                                                begin
                                                curObjectType:=UI_LABEL;//
                                                tmp.OnDraw:=OnLabelDraw;
                                                end;
                                        if word='image' then               //
                                                begin
                                                curObjectType:=UI_IMAGE;//
                                                tmp.OnDraw:=OnImageDraw;
                                                tmp.DATA:=0;
                                                end;
                                        if word='checkbox' then//
                                                begin
                                                curObjectType:=UI_CHECKBOX;
                                                tmp.data:=0;
                                                tmp.OnDraw:=OnCheckBoxDraw;
                                                end;
                                        if word='progressbar' then//
                                                begin
                                                curObjectType:=UI_PROGRESS;
                                                tmp.OnDraw:=OnProgressDraw;
                                                end;

                                        tmp.UIType:=curObjectType; //    . 


                                        word:='';//  

                                        continue;// 
                                        end;

                                if (state=STATE_COMPONENTS) then//    ,
                                        begin
                                        if (ch='=')then// - =,    
                                                begin
                                                curField:=word;//  -  
                                                write(log,'    curfield:'+word);//
                                                word:='';//
                                                inc(state);//- -  
                                                continue;// 
                                                end;
                                        if (word='object') then      //   ,
                                                begin
                                                writeln(log,'object found:'+word);//
                                                parentObjectString:=curObjectString;  //  -   
                                                parentObjectType:=curObjectType;//  -   
                                                state:=STATE_OBJNAME;// -   

                                                index:=gmUIAdd;// 
                                        //ZeroMemory(tmp,SizeOf(TUI));
                                                tmp:=gmUI_Items[index];
                                                 tmp.parent:=curObjectID;

                                                SetLength(controls,Length(controls)+1);//  
                                                controls[Length(controls)-1]:=index;//  - 

                                                word:='';//

                                                continue;// 
                                                end;
                                        if (word='end')then//   ,
                                                begin
                                                writeln(log,'Object closed'+#13+'--------------------------');//
                                                if (curObjectType=UI_WINDOW) or (curObjectType=UI_PANEL) then//    ,
                                                begin
                                                SetLength(offx,Length(offx)-1);// -
                                                SetLength(offy,Length(offy)-1);
                                                end;

                                                curObjectString:=parentObjectString;//   -  
                                                curObjectType:=parentObjectType;//  -  
                                                word:='';//
                                                continue;// 
                                                end;
                                        end;
                                if (state=STATE_FIELDVALUE)then       //   
                                        begin
                                        writeln(log,'  Field value:'+line);//
                                        //        
                                        if curField='data' then //   - 
                                                tmp.DATA:=str2int(line);//   
                                        if curField='left' then//   - ,
                                                begin
                                                tmp.X:=str2int(line)+offx[Length(offx)-1];//   + 
                                                if (curObjectType=UI_PANEL)or(curObjectType=UI_WINDOW) then//    ,  
                                                        begin
                                                        SetLength(offx,Length(offx)+1);
                                                                offx[Length(offx)-1]:=str2int(line)+offx[Length(offx)-2];
                                                        end;
                                                if curObjectType=UI_WINDOW then x:=str2int(line);
                                                end;
                                        if curField='top' then
                                                begin
                                                tmp.Y:=str2int(line)+offy[Length(offy)-1];
                                                if (curObjectType=UI_PANEL)or(curObjectType=UI_WINDOW) then
                                                        begin
                                                        SetLength(offy,Length(offy)+1);
                                                        offy[0]:=0;
                                                        offy[Length(offy)-1]:=str2int(line)+offy[Length(offy)-2];
//                                                        offy[1]:=0;
                                                        end;
                                                if curObjectType=UI_WINDOW then y:=str2int(line);
                                                end;
                                        if curField='width' then
                                                begin
                                                if curObjectType=UI_WINDOW then width:=str2int(line);
                                                tmp.Width:=str2int(line);
                                                end;
                                        if curField='height' then
                                                begin
                                                if curObjectType=UI_WINDOW then height:=str2int(line);
                                                tmp.Height:=str2int(line);
                                                end;
                                        if (curField='caption')or(curField='text') then
                                                tmp.Caption:=line;
                                        if (curField='path')and(curObjectType=UI_IMAGE)then tmp.caption:=line;
                                        if (curField='size')and(curObjectType=UI_LABEL)then tmp.height:=str2int(line);
                                        if (curField='r')then tmp.R:=str2int(line);
                                        if (curField='g')then tmp.G:=str2int(line);
                                        if (curField='b')then tmp.B:=str2int(line);
                                        if (curField='a')then tmp.A:=str2int(line);
                                        if (curField='modal')then
                                                begin
                                                        if(line='OK')then
                                                        tmp.Result:=M_OK;
                                                        if(line='CANCEL')then
                                                        tmp.Result:=M_CANCEL;
                                                        if(line='EXIT')then
                                                        tmp.result:=M_EXIT;
                                                end;
                                        if curField='visible' then
                                                begin
                                                        if line='true' then tmp.visible:=true else
                                                                tmp.visible:=false;
                                                end;
                                        if curField='modalstyle' then   //   -   
                                                begin
                                                        if line='static' then modalstyle:=STATICFORM;
                                                        if (line='modal')or(line='form') then modalstyle:=FORM;
                                                        if line='dialog' then modalstyle:=DIALOG;
                                                end;


                                        line:='';   //
                                        state:=STATE_COMPONENTS;// .   ..
                                        continue;// .
                                        end;

                                end;
                end;
  //      finally
  {}
        offx:=nil;offy:=nil;// 
        writeln(log,'Form parsed');
        closeFile(f);// 
        closeFile(log);
   //     end;
//   end;
end;

function TUIForm.GetItem(index:string):PUI;
var
i:integer;
begin
result:=nil;
for i:=0 to Length(controls)-1 do
if Assigned(gmUI_Items[controls[i]]) then
   if gmUI_Items[controls[i]].name=index then
   begin
   result:=gmUI_Items[controls[i]];
   exit;
   end;
end;

function TUIForm.SetOnPress(name:string;Proc:TUIOnPress):boolean;
var
i:integer;
begin
for i:=0 to Length(controls)-1 do
if gmUI_Items[controls[i]].name=name then
        begin
        result:=true;
     gmUI_Items[controls[i]].OnPress:=proc;
     end else result:=false;
end;



function TUIForm.SetOnDraw(name:string;Proc:TUIOnDraw):boolean;
var
i:integer;
begin
for i:=0 to Length(controls)-1 do
if gmUI_Items[controls[i]].name=name then
        begin
        result:=true;
     gmUI_Items[controls[i]].OnDraw:=proc;
     end else result:=false;
end;

function TUIForm.SetOnMouseMove(name:string;Proc:TUIOnMouseMove):boolean;
var
i:integer;
begin
for i:=0 to Length(controls)-1 do
if gmUI_Items[controls[i]].name=name then
        begin
        result:=true;
     gmUI_Items[controls[i]].OnMouseMove:=proc;
     end else result:=false;
end;

function TUIForm.SetOnChar(name:string;Proc:TUIOnChar):boolean;
var
i:integer;
begin
for i:=0 to Length(controls)-1 do
if gmUI_Items[controls[i]].name=name then
        begin
        result:=true;
     gmUI_Items[controls[i]].OnChar:=proc;
     end else result:=false;
end;

constructor TUiForm.Create(path:string);

begin
//if empty then  begin
inherited Create;
//
modalstyle:=STATICFORM;
gmUI_Modal:=M_RUNNING;


  Init;
  empty:=true;
  Load(path);
  gmUI_Status:=modalstyle;
  empty:=false;
//  empty:=false;
  //end;
end;

destructor TUiForm.Destroy;
var
i:integer;
begin

gmUI_Status:=STATICFORM;
empty:=true;
for i:=0 to Length(controls)-1 do
        gmUIDelete(controls[i]);
if gmUI_MOdal=M_NONE then gmUI_Modal:=M_EXIT;
try
//        SetLength(controls,0);
//        controls:=nil;
        except
        end;
inherited Destroy;
end;

function TUiForm.AddControl(name:string):word;
var
index:word;
tmp:PUI;
begin
        index:=gmUIAdd;
//        writeln(log,'object found index:'+int2str(index));
                                        //ZeroMemory(tmp,SizeOf(TUI));

//        state:=STATE_OBJNAME;
        tmp:=gmUI_Items[index];

//        tmp.parent:=curObjectID;

        tmp.OnDraw:=nil;
        tmp.OnChar:=nil;
        tmp.OnCharEx:=nil;
        tmp.OnKeyDown:=nil;
        tmp.OnKeyUp:=nil;
        tmp.OnMouseKeyDown:=nil;
        tmp.OnMouseKeyUp:=nil;
        tmp.OnMouseMove:=nil;
        tmp.OnMouseOver:=nil;
        tmp.OnPress:=nil;
        tmp.OnChangeCaption:=nil;
        tmp.visible:=true;
        tmp.parent:=modalstyle;

        SetLength(controls,Length(controls)+1);
        controls[Length(controls)-1]:=index;

        result:=index;
end;

function gmUIIsMouseOver(id:Word):boolean;
begin
result:=gmUI_Items[id].over;
end;

function gmUIIsFocused(Id:word):boolean;
begin
  if gmUI_Focus = Id then
    result:=true
  else
    result:=false;
end;

function gmUIIsPressed(id:word):boolean;
begin
result:=gmUI_Items[id].pressed;
end;

function gmUIGetFocus:word;
begin
  result:=gmUI_Focus;
end;

function gmUIAdd:word;
var
  i:cardinal;
begin
  if Length(gmUI_Items)>gmUI_Count then
    begin
      for i:=0 to Length(gmUI_Items)-1 do
        if not Assigned(gmUI_Items[i]) then
          begin
            inc(gmUI_Count);
            New(gmUI_Items[i]);
            result:=i;
            gmUI_Focus:=result;
            exit;
          end;
    end;
  inc(gmUI_Count);
  SetLength(gmUI_Items,gmUI_Count);
  New(gmUI_Items[gmUI_Count-1]);
  result:=gmUI_Count-1;
  gmUI_Items[gmUI_Count-1].visible:=true;
  gmUI_Items[gmUI_Count-1].adata:=nil;
  gmUI_Items[gmUI_Count-1].OnMouseMove:=nil;
  gmUI_Focus:=result;
end;

procedure gmUIDelete(Id:word);
begin
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    begin
      dec(gmUI_Count);
      gmUI_Items[Id].Caption:='';
      Dispose(gmUI_Items[Id]);
      gmUI_Items[Id]:=nil;
    end;
end;


procedure gmUIInit;
          function AddFont(path:string;space,size:integer):byte;
          var
          i:integer;
          begin
            result:=ueRenderAddFont;
                ueRenderSetSpace2Font(result,space);

                    for I := 1 to Length(ueFnt_StandartText)-1 do
                    ueRenderAddChar2Font(result,
                    ord(ueFnt_StandartText[i]),PChar(path),size);
          end;
begin
  gmUI_Count:=0;
  gmUI_Status:=APPLICATION;
  SetLength(gmUI_Items,0);
  MainFont:=ueRenderAddSprite('MainFont');
  MainSmallfont:=uerenderAddSprite('MainSmallFont');

Arial10:=AddFont('arial',10,10);
Arial15:=AddFont('arial',15,15);
Arial20:=AddFont('arial',20,20);
Corier10:=AddFont('corier new',10,10);
Corier15:=AddFont('corier new',15,15);
BlackAdder15:=AddFont('blackadder itc',5,15);
Blackadder30:=AddFont('blackadder itc',15,30);
BankGothic30:=AddFont('bankgothic md bt',30,30);


  sprites[WINDOWSprite]:=ueRenderAddSprite('UIWindow');
  sprites[BUTTONSprite]:=ueRenderAddSprite('UIButton');
  sprites[ButtonOverSprite]:=ueRenderAddSprite('UIButtonOver');
  sprites[CheckBoxOverSprite]:=ueRenderAddSprite('UICheckBoxOver');
  sprites[CheckBoxOver2Sprite]:=ueRenderAddSprite('UICheckBoxOver2');
  sprites[CheckBoxSprite]:=ueRenderAddSprite('UICheckBox');
  sprites[CheckBox2Sprite]:=ueRenderAddSprite('UICheckBox2');
  sprites[EditOverSprite]:=ueRenderAddSprite('UIEditOver');
  sprites[EditSprite]:=ueRenderAddSprite('UIEdit');
  consoleFont:=ueRenderAddSprite('ConsoleFont');
end;

procedure gmUIDeInit;
var
  i:word;
begin
  if Length(gmUI_Items)>0 then
    for i:=0 to Length(gmUI_Items)-1 do
      gmUIDelete(i);
  for i:=1 to Length(sprites) do
  ueRenderDeleteSprite(i);
  gmUI_Count:=0;
  SetLength(gmUI_Items,0);
end;


function gmUINewLabel(X,Y:integer;size:word;caption:string;R,G,B,A:integer;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
//  tmp.Width:=Width;
  tmp.Height:=size;
  tmp.UIType:=UI_LABEL;
  tmp.R:=R;  tmp.G:=G;  tmp.B:=B;  tmp.A:=A;

  gmUISetText(result,caption);

  if @onDraw<>nil then
  tmp.OnDraw:=OnDraw else
  tmp.OnDraw:=OnLabeldraw;

  tmp.OnMouseMove:=OnMouseMove;
  tmp.OnPress:=OnPress;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;
end;

function gmUINewInputBox(X,Y:integer;Width,Height:word;
  OnDraw:TUIOnDraw;OnChangeCaption:TUIOnChangeCaption):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
  tmp.Width:=Width;
  tmp.Height:=Height;
  tmp.UIType:=UI_INPUT_AUTO;
  tmp.OnDraw:=OnDraw;
  tmp.OnChangeCaption:=OnChangeCaption;
  tmp.OnCharEx:=gmUIOnCharEx;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;
end;



function gmUINewInputBoxEx(X,Y:integer;Width,Height:word;
  OnDraw:TUIOnDraw;OnChar:TUIOnChar):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
  tmp.Width:=Width;
  tmp.Height:=Height;
  tmp.UIType:=UI_INPUT_MANUAL;
  tmp.OnDraw:=OnDraw;
  tmp.OnChar:=OnChar;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;
end;

function gmUINewCheckBox(X,Y:integer;Width,Height:word;
  OnDraw:TUIOnDraw;OnPress:TUIOnPress):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
  tmp.Width:=Width;
  tmp.Height:=Height;
  tmp.UIType:=UI_CHECKBOX;
  tmp.OnDraw:=OnCheckBoxDraw;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;
end;


function gmUINewWindow(X,Y:integer;width,height:word;R,G,B,A:integer;caption:string;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
  tmp.Width:=Width;
  tmp.Height:=Height;
  tmp.UIType:=UI_WINDOW;
  tmp.R:=R;  tmp.G:=G;  tmp.B:=B;  tmp.A:=A;
  tmp.Caption:=caption;

  if @OnDraw<>nil then
  tmp.OnDraw:=OnDraw else
  tmp.OnDraw:=OnWindowDraw;
  tmp.visible:=true;


  if assigned(OnMouseMove)then
  tmp.OnMouseMove:=OnMouseMove;

  if Assigned(OnPress)then
  tmp.OnPress:=OnPress
  end;

function gmUINewImage(X,Y:integer;width,height:word;sprite:string;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
  tmp.Width:=Width;
  tmp.Height:=Height;
  tmp.UIType:=UI_IMAGE;
  tmp.DATA:=ueRenderAddSprite(PChar(sprite));
  if @OnDraw<>nil then
  tmp.OnDraw:=OnDraw else
  tmp.OnDraw:=OnImageDraw;

  tmp.OnMouseMove:=OnMouseMove;
  tmp.OnPress:=OnPress;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;
  end;

function gmUINewPanel(X,Y:integer;width,height:word;R,G,B,A:integer;
  OnDraw:TUIOnDraw=nil;OnPress:TUIOnPress=nil;OnMouseMove:TUIOnMouseMove=nil):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
  tmp.Width:=Width;
  tmp.Height:=Height;
  tmp.UIType:=UI_PANEL;
  tmp.R:=r;  tmp.G:=g;  tmp.B:=b;  tmp.A:=a;
  if @OnDraw<>nil then
  tmp.OnDraw:=OnDraw else
  tmp.OnDraw:=OnpanelDraw;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;

  if assigned(OnMouseMove)then
  tmp.OnMouseMove:=OnMouseMove;

  if Assigned(OnPress)then
  tmp.OnPress:=OnPress;
  end;




function gmUINewButton(X,Y:integer;Width,Height:word;
  OnDraw:TUIOnDraw;OnPress:TUIOnPress;OnMouseMove:TUIOnMouseMove=nil):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=X;
  tmp.Y:=Y;
  tmp.Width:=Width;
  tmp.Height:=Height;
  tmp.UIType:=UI_BUTTON;
  tmp.OnDraw:=OnDraw;
  tmp.OnMouseMove:=OnMouseMove;
  tmp.OnPress:=OnPress;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;
end;

function IsInside
  (a: Array of MyPoint; b:MyPoint): Boolean;
var Count, K, J : Integer;
begin
 Result := False;
 Count := Length(a);
 J := Count-1;
 for K := 1 to Count-1 do begin
  if ((a[K].Y <=b.y) and (b.y < a[J].Y)) or
     ((a[J].Y <=b.y) and (b.y < a[K].Y)) then
  begin
   if (b.x < (a[j].X - a[K].X) *
      (b.y - a[K].Y) /
      (a[j].Y - a[K].Y) + a[K].X) then
       Result := not Result;
   end;
   J := K;
 end;
end;


{/END}

function gmUINewButtonEx(vertex:Pointer;OnDraw:TUIOnDraw;OnPress:TUIOnPress;OnMouseMove:TUIOnMouseMove=nil):word;
var
  tmp:PUI;
begin
  result:=gmUIAdd;

  tmp:=gmUI_Items[result];

  ZeroMemory(tmp,SizeOf(TUI));

  tmp.X:=0;
  tmp.Y:=0;
  tmp.Width:=0;
  tmp.Height:=0;
  tmp.UIType:=UI_BUTTON_EX;
  tmp.OnDraw:=OnDraw;
  tmp.OnMouseMove:=OnMouseMove;
  tmp.OnPress:=OnPress;
  tmp.visible:=true;
  tmp.parent:=APPLICATION;
  tmp.adata:=vertex;
end;

function gmUIGetText(Id:word):string;
begin
  result:='';
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    result:=gmUI_Items[Id].Caption;
end;

function gmUIGetX(id:word):integer;
begin
  result:=-1;
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    result:=gmUI_Items[Id].X;
end;

function gmUIGetY(id:word):integer;
begin
  result:=-1;
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    result:=gmUI_Items[Id].Y;
end;

procedure gmUISetOnKeyDown(id:word;proc:TUIOnKeyDown);
begin
if id>=Length(gmUI_Items)then exit;
if assigned(gmUI_Items[id])then
        gmUI_Items[id].OnKeyDown:=proc;
end;

procedure gmUISetOnMouseOver(id:word;proc:TUIOnMouseMove);
begin
if id>=Length(gmUI_Items)then exit;
if assigned(gmUI_Items[id])then
        gmUI_Items[id].OnMouseMove:=proc;
end;

procedure gmUISetOnPress(id:word;proc:TUIOnPress);
begin
if id>=Length(gmUI_Items)then exit;
if assigned(gmUI_Items[id])then
        gmUI_Items[id].OnPress:=proc;
end;

procedure gmUISetOnDraw(id:word;proc:TUIOnDraw);
begin
if id>=Length(gmUI_Items)then exit;
if assigned(gmUI_Items[id])then
        gmUI_Items[id].OnDraw:=proc;
end;

procedure gmUISetXY(Id:word;x:integer;y:integer);
begin
if id>=Length(gmUI_Items)then exit;
if assigned(gmUI_Items[id])then
        begin
        if x>=0 then
        gmUI_Items[id].x:=x;
        if y>=0 then
        gmUI_Items[id].y:=y;
        end;

end;

procedure gmUISetText(Id:word;const Text:string);
begin
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    gmUI_Items[Id].Caption:=Text;
end;

procedure gmUISetParent(id:word;parent:word);
begin
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    gmUI_Items[Id].parent:=parent;

end;

procedure gmUISetVisible(id:word;val:boolean);
begin
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    gmUI_Items[Id].visible:=val;

end;

procedure gmUIDraw;
var
  i:word;
begin
  if gmUI_Count = 0 then
    exit;
  for i:=0 to Length(gmUI_Items)-1 do
    if Assigned(gmUI_Items[i]) then
      if Assigned(@gmUI_Items[i].OnDraw) then
      if gmUI_Items[i].visible then
        gmUI_Items[i].OnDraw(
          i,
          gmUI_Items[i].X,
          gmUI_Items[i].Y,
          gmUI_Items[i].Width,
          gmUI_Items[i].Height);
end;

procedure gmUISetFocus(Id:word);
begin
  if Id>=Length(gmUI_Items)then
    exit;
  if Assigned(gmUI_Items[Id])then
    gmUI_Focus:=Id;
end;

procedure gmUISetValue(id:word;field:string;value:Variant);
var
tmp:PUI;
i:integer;
begin
tmp:=gmUI_Items[id];
if tmp.fieldcount<>0 then
for i:=1 to tmp.fieldcount do
        begin
        if tmp.fields[i].name=field then
                begin
                tmp.fields[i].value:=value;
                exit;
                end;
        end;
inc(tmp.fieldcount);
tmp.fields[tmp.fieldcount].name:=field;
tmp.fields[tmp.fieldcount].value:=value;
end;

function gmUIGetValue(id:word;field:string):Variant;
var
tmp:PUI;
i:integer;
begin
tmp:=gmUI_Items[id];
for i:=1 to tmp.fieldcount do
        begin
        if tmp.fields[i].name=field then
                begin
                result:=tmp.fields[i].value;
                exit;
                end;
        end;
result:=0;
end;

//---

procedure gmUIOnKeyDown(Key:integer);
begin
  if gmUI_Focus = -1 then
    exit;
  if gmUI_Focus>=Length(gmUI_Items) then
    exit;
  if Assigned(gmUI_Items[gmUI_Focus]) then
    begin
      if Assigned(gmUI_Items[gmUI_Focus].OnKeyDown) then
        gmUI_Items[gmUI_Focus].OnKeyDown(gmUI_Focus,Key);
        //gmUIOnChar(gmUI_Focus,chr(key));


      case gmUI_Items[gmUI_Focus].UIType of
        UI_INPUT_AUTO,
        UI_INPUT_MANUAL:
          begin
            case Key of
              VK_TAB:
                if Assigned(gmUI_OnChangeFocus) then
                  gmUI_OnChangeFocus(gmUI_Focus);
              else
                if Assigned(gmUI_Items[gmUI_Focus].OnChar) then gmUI_Items[gmUI_Focus].OnChar(gmUI_Focus,chr(key))
              end;
          end;
        UI_BUTTON:
          begin
            case Key of
              VK_RETURN:
                if Assigned(gmUI_Items[gmUI_Focus].OnPress) then
                  gmUI_Items[gmUI_Focus].OnPress(gmUI_Focus);
              VK_TAB:
                if Assigned(gmUI_OnChangeFocus) then
                  gmUI_OnChangeFocus(gmUI_Focus);
              end;
          end;
        end;
    end;
end;

procedure gmUIOnKeyUp(Key:integer);
begin
  if gmUI_Focus = -1 then
    exit;
  if gmUI_Focus>=Length(gmUI_Items) then
    exit;
  if Assigned(gmUI_Items[gmUI_Focus]) then
    begin
      if Assigned(gmUI_Items[gmUI_Focus].OnKeyUp) then
        gmUI_Items[gmUI_Focus].OnKeyUp(gmUI_Focus,Key);

      {case gmUI_Items[gmUI_Focus].UIType of
        UI_BUTTON:
          if Assigned(gmUI_Items[gmUI_Focus].OnPress) then
            gmUI_Items[gmUI_Focus].OnPress(gmUI_Focus);
        end;}
    end;
end;

procedure gmUIOnMouseMove(X,Y:integer);
var
  i:word;
  a:MyPoint;
  found:integer;
begin
  gmUI_CursorX:=X;
  gmUI_CursorY:=Y;

  a.x:=x;
  a.y:=y;
//---------------
found:=-1;
if gmUI_Count = 0 then
    exit;
  for i:=0 to Length(gmUI_Items)-1 do
    if Assigned(gmUI_Items[i]) then
        if (gmUI_Items[i].parent=gmUI_Status)or(gmUI_status=STATICFORM) then
    if gmUI_Items[i].UIType<>UI_BUTTON_EX then
      begin
        if ((X>=gmUI_Items[i].X)and
           (X<=gmUI_Items[i].X+gmUI_Items[i].Width))and
           ((Y>=gmUI_Items[i].Y)and
           (Y<=gmUI_Items[i].Y+gmUI_Items[i].Height))then
          begin
              gmUI_Items[i].over:=true;
              found:=i;
              if Assigned(gmUI_Items[i].OnMouseMove) then
                gmUI_Items[i].OnMouseMove(i,
                  X-gmUI_Items[i].X,
                  Y-gmUI_Items[i].Y);
          end else gmUI_ITems[i].over:=false;
      end else
          begin
          end;
    if (gmUI_Over<>found )and(gmUI_Over<>-1) then
    if Assigned(gmUI_Items[gmUI_Over]) then
       if Assigned(gmUI_Items[gmUI_Over].OnMouseOver) then
       gmUI_Items[gmUI_Over].OnMouseOver(gmUI_Over,x,y);
    gmUI_Over:=found;

end;

procedure gmUIOnMouseKeyDown(X,Y:integer;Left,Right:boolean);
var
  i:word;
  a:MyPoint;
begin
  if gmUI_Count = 0 then
    exit;
  for i:=0 to Length(gmUI_Items)-1 do
    if Assigned(gmUI_Items[i]) then
    begin
    //gmUI_Items[i].pressed:=false;
    if(gmUI_Items[i].visible) then
        if (gmUI_Items[i].parent=gmUI_Status)or(gmUI_Status=STATICFORM) then
      begin
//      SetLength(pa,10);
 {     if Assigned(gmUI_Items[i].adata) then
         pa:=(gmUI_Items[i].adata);}
      a.x:=X;a.y:=Y;
      if  (((gmUI_Items[i].UIType<>UI_BUTTON_EX) and
           ((X>=gmUI_Items[i].X)and
           (X<=gmUI_Items[i].X+gmUI_Items[i].Width))and
           ((Y>=gmUI_Items[i].Y)and
           (Y<=gmUI_Items[i].Y+gmUI_Items[i].Height)))
//           or
//           ((gmUI_Items[i].UIType=UI_BUTTON_EX)and IsInside(pa,a)))
           )then

          begin
           //     gmUI_Items[i].pressed:=true;
            if i = gmUI_Focus then
              if Assigned(gmUI_Items[i].OnMouseKeyDown) then
                gmUI_Items[i].OnMouseKeyDown(i,
                  X-gmUI_Items[i].X,
                  Y-gmUI_Items[i].Y,
                  Left,Right);

            case gmUI_Items[i].UIType of
              UI_BUTTON,UI_INPUT_AUTO:
                begin
                if gmUI_Items[i].over then
                  if gmUI_Items[i].visible then
                if Assigned(gmUI_Items[i].OnPress) then
                  begin
                  gmUI_Items[i].OnPress(i);
                  gmUI_Focus:=i;
                  exit;
                  end;
                if assigned(gmUI_Items[i])then
                if    gmUI_Items[i].UIType=UI_BUTTON then
                        begin
                        case gmUI_Items[i].result of
                        M_OK:gmUI_Modal:=M_OK;//Destroy;
                        M_EXIT:gmUI_Modal:=M_EXIT;//Destroy;
                        end;
                        end;
                end;
                UI_CHECKBOX:
                begin
                gmUI_Items[i].DATA:=1-gmUI_Items[i].DATA;
                if Assigned(gmUI_Items[i].OnPress) then
                  gmUI_Items[i].OnPress(i);

                end;
                UI_IMAGE:
                begin
                           if Assigned(gmUI_Items[i].OnPress) then
                           begin
                           gmUI_Items[i].OnPress(i);
                           gmUI_Focus:=i;
                           exit;
                           end;
                end;
              end;

            gmUI_Focus:=i;
            //exit;
          end;
          end;
      end;
//    pa:=nil;
end;

procedure gmUIOnMouseKeyUp(X,Y:integer;Left,Right:boolean);
var
  i:word;
begin
  if gmUI_Count = 0 then
    exit;
  for i:=0 to Length(gmUI_Items)-1 do
    if Assigned(gmUI_Items[i]) then
      begin
 //     gmUI_Items[i].pressed:=false;
        if ((X>=gmUI_Items[i].X)and
           (X<=gmUI_Items[i].X+gmUI_Items[i].Width))and
           ((Y>=gmUI_Items[i].Y)and
           (Y<=gmUI_Items[i].Y+gmUI_Items[i].Height))then
          begin
            if i = gmUI_Focus then
              if Assigned(gmUI_Items[i].OnMouseKeyUp) then
                gmUI_Items[i].OnMouseKeyUp(i,
                  X-gmUI_Items[i].X,
                  Y-gmUI_Items[i].Y,
                  Left,Right);

            exit;
          end;
      end;
end;



//---

procedure ueRenderFontBox(font:byte;text:PCHar;x,y:integer;width,height,size:integer;R,G,B,A:byte);
var
curstring:WideString;
cur:integer;l,h:integer;
offy:integer;
begin
curstring:='';offy:=0;l:=0;h:=0;
for cur:=0 to Length(text)-1 do
begin
curstring:=curstring+text[cur];
inc(l);
if (l)=width then
        begin
        dec(offy,size);
        ueRenderFontTextEx( font,curstring,x,y+offy,r,g,b,a,width);
        l:=0;
        inc(h);
        curstring:='';
        if h>height then break;
        end;
end;
dec(offy,size);
ueRenderFontTextEx( font,curstring,x,y+offy,r,g,b,a,width);
end;


end.
