unit gmVillage;

interface
uses gmUI;

var
gmVillage_Background:array [1..6]of word;

procedure gmVillageRun;
procedure gmVillageInit;
procedure gmVillageDeInit;

var
curpits:array[1..19]of word;
curvilltype:word;
PITLEVEL:array[1..19]of word;
MAXPITLEVEL:array[1..4]of word;
pitsimg:word;
pitover:word;
villupgrade:TUIForm;
villconstructing:boolean=false;

MyResourcesProd:array[1..5]of integer;
//MyResources:array[1..5]of real;


const
NONE=19;
CITY_PIT=0;
X1=1;
X2=3;
Y1=2;
Y2=4;
PitRects:array[1..4,0..18]of integer=( //      
//   0   1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16  17  18
{X1}(149 ,28  ,102 ,187, 265 ,314 ,315 ,283 ,228 ,149 ,84  ,22  ,15  ,93  ,99  ,186 ,252 ,232 ,160),
{Y1}(162 ,254 ,313 ,308 ,285 ,229 ,144 ,64  ,18  ,21  ,46  ,95  ,177 ,186 ,116 ,86  ,148 ,219 ,248),
{X2}(228 ,94  ,170 ,256 ,329, 373 ,384 ,337 ,267 ,212 ,145 ,86  ,72  ,131 ,147 ,234 ,304 ,289 ,200),
{Y2}(216 ,305 ,357 ,358 ,332 ,281 ,197 ,115 ,66  ,70  ,81  ,162 ,237 ,249 ,170 ,142 ,200 ,270 ,300));

PitXY:array[1..2,1..18]of integer=(
(55,  125, 208, 285, 332, 341, 301, 240, 175, 108, 50,  36, 102,115, 200, 270, 257, 173),
(280, 328, 328, 309, 246, 165, 84,  36,  40,  59,  125, 203,213,135, 107, 167, 238, 267));

PITNAMES:array[0..4]of string[5]=('City','Wood','Clay','Iron','Food');

PitShablons:array[1..6,1..18]of  word=(//      .  6
(4,4,4,1,3,3,4,2,1,2,4,4,4,4,1,3,2,4),
(3,3,4,1,3,3,4,2,1,2,4,4,4,4,1,3,2,2),
(3,1,4,1,3,3,4,2,1,2,4,4,4,4,1,3,2,2),
(2,1,4,1,3,3,4,2,1,2,4,4,4,4,1,3,2,2),
(3,1,4,1,3,3,4,2,1,2,4,4,4,4,1,3,2,1),
(3,4,4,1,4,4,4,4,4,2,4,4,4,4,4,4,4,4));

PITINFO:array[0..3]of PChar=(   // 
'The woodchopper cuts down trees to produce wood. By increasing its level you increase its wood production.',
'Clay is produced here. By increasing its level you increase its clay production.',
'Here miners produce the precious resource iron. By increasing the mine`s level you increase its iron production.',
'Your population`s food is produced here. By increasing the farm`s level you increase its crop production.');


implementation
uses ueMain,ueTypes,windows,
gmMain,gmGlobal,gmCity,gmTimeCalc,kol,
frmHelpForm,frmPause;

procedure OnCustomPitImageDraw(id:word;x,y:integer;width,height:word);
var
i:integer;
begin
OnImageDraw(id,x,y,width,height);
    for i:=1 to 18 do
    ueRenderFontText(blackadder30,int2str(PITLEVEL[i]),PitXY[1][i]+X-6,PitXY[2][i]+Y+4,255,0,0,255);

end;

//----------------------------------  -----------------
procedure OnUpgradeCancelClick(id:word);
begin
villupgrade.visible:=false;
end;

procedure OnUpgradeClick(id:word);
begin
{inc(PITLEVEL[pitover]);
if (PITLEVEL[pitover])>MAXPITLEVEL[curpits[pitover+1]] then
   MAXPITLEVEL[curpits[pitover+1]]:=(PITLEVEL[pitover]);
GenerateBuildList;}
if tmBuildPit(3000,pitover,PITLEVEL[pitover]+1)>0 then
  begin
    showmessage('Resource deficit!');
  end;
villupgrade.visible:=false;
//Place it here
end;


//-----------------------------------------------------------------------------

procedure gmVillOnPitPress(id:word);
begin
if pitover<>NONE then
 if pitover=CITY_PIT then
    begin
    gmVillageDeInit;
    gmCityRun;
    page:=PAGE_CITY;
    end
    else
        if not villconstructing then 
        begin
        villupgrade.visible:=true;
        villupgrade['simage'].DATA:=BigRes[curpits[pitover+1]];
        villupgrade['name'].Caption:=PITNAMES[curpits[pitover+1]];
        villupgrade['demolish'].visible:=false;
        end;
end;

procedure Swap(var a,b:integer);
var
t:integer;
begin
t:=a;
a:=b;
b:=t;
end;

function InRect(X,Y:integer;X1,Y1,X2,Y2:integer):boolean;

begin
if(x1>x2)then swap(x1,x2);
if(y1>y2) then swap(y1,y2);
 if(X>=X1)and(X<=X2)and(Y>=Y1)and(Y<=Y2)then result:=true else result:=false;
end;

procedure gmVillOnPitMove(id:word;x,y:integer);
var
i:integer;
begin
pitover:=19;
//villform['overimage'].DATA:=BigRes[curpits[i+1]];
helpform['overimage'].visible:=false;
helpform['name'].Caption:='';
     for i:=0 to 18 do
     if InRect(x,y,PitRects[X1][i],PitRects[Y1][i],PitRects[X2][i],PitRects[Y2][i]) then
        begin
        pitover:=i;
        if (i<>0) then
           begin
             helpform['overimage'].DATA:=BigRes[curpits[i+1]];
             helpform['overimage'].visible:=true;
             helpform['name'].Caption:=PITNAMES[curpits[i+1]];
             end else
                 begin
                  helpform['overimage'].DATA:=BigRes[0];
                  helpform['overimage'].visible:=true;
                  helpform['name'].Caption:='City';
                 end;
        exit;
        end;
end;

function SetRandomPits(var pits:array of word):word;
var
i,j:integer;
begin
i:=random(5);
for J:=1 to 18 do
    pits[j]:=PitShablons[i+1][j];
result:=i+1;
end;


procedure gmVillageIdle;
var
i:integer;
s:TStackStructure;
begin
//Draw City
    ueRenderRectangle(0,0,gmMain_width,gmMain_Height,
    225,242,208,255,true);
    ueRenderRectangle(0,gmMain_Height-64,gmMain_width,64,
    225,242,208,255,true);
   { ueRenderSprite(75,75,gmMain_Height-64-150,gmMain_Height-64-150,
    gmVillage_Background,255);}
    gmDrawTop;             //  
                           //--------

    gmUIDraw;              // 
    tmRecalcStack;

    if not gmUIIsMouseOver(pitsimg) then pitover:=19;

    if(pitover<>19)then
    if pitover=0 then
    ueRenderFontBox(arial10,'Click here to go to city...',610,160,20,5,10,0,0,128,255) else
    ueRenderFontBox(arial10,PITINFO[curpits[pitover+1]-1],610,160,20,5,10,0,0,128,255) else


      if constructing then
       begin
      // villform['LABEL1'].Caption:='Constructing...';
       helpform['bar1'].visible:=true;
       if tmFindFirst(RT_UPGRADE_STRUCTURE,s) then
              helpform['bar1'].DATA:=round(int(abs((1-s.time/s.totaltime)*100-5)))
              else if tmFindFirst(RT_BUY_STRUCTURE,s) then
                   helpform['bar1'].DATA:=round(int(abs((1-s.time/s.totaltime)*100-5)));
       end else
           begin
//           villform['name'].Caption:='';
           helpform['bar1'].visible:=false;
           end;

       if villconstructing then
       begin
     //  villform['LABEL2'].Caption:='Constructing...';
       helpform['bar2'].visible:=true;
       if tmFindFirst(RT_BUY_PIT,s) then
              helpform['bar2'].DATA:=round(int(abs((1-s.time/s.totaltime)*100-5)))
       end else
           begin
  //         villform['name'].Caption:='';
           helpform['bar2'].visible:=false;
           end;


    for i:=1 to 4 do
    begin
    helpform['cur'+int2str(i)].caption:=int2str(round(int(gamedata.res[i])));
    helpform['prod'+int2str(i)].caption:=int2str(MyResourcesProd[i]);
    end;
    helpform['prod4'].caption:=int2str(MyResourcesProd[4]-gamedata.vils[0].pop);
    helpform['cur5'].Caption:=int2str(gamedata.vils[0].pop);
    


    for i:=1 to 9 do
    begin
    helpform['LABEL'+int2str(i)].caption:=
      int2str(gamedata.vils[0].army.troops[i]);
    end;

    ueREnderSprite(gmMain_CursorX-8,gmMain_CursorY-8,16,16,
    cursor,250);           // 
end;

procedure gmVillageInit;
var
i:integer;
begin
for i:=1 to 4 do MAXPITLEVEL[i]:=0;
curvilltype:=SetRandomPits(curpits);
{for i:=1 to 4 do
    MyResources[i]:=gamedata.res[i];}
{for i:=1 to 6 do
gmVillage_Background[i]:=ueRenderAddSprite(PChar('vill_bg'+int2str(i)));}
end;

procedure gmVillageInitEx;
var
i:integer;
begin
pitsimg:=gmUINewImage(75,100,gmMain_Height-64-150,gmMain_Height-64-150,'vill_bg'+int2str(curvilltype),OnCustomPitImageDraw,gmVillOnPitPress,gmVillOnPitMove);
villupgrade:=TUIForm.Create('upgrade.frm');
villupgrade.visible:=false;
villupgrade['cancel'].OnPress:=OnUpgradeCancelClick;
villupgrade['upgrade'].OnPress:=OnUpgradeClick;
{ueRenderSprite(75,75,gmMain_Height-64-150,gmMain_Height-64-150,
    gmVillage_Background,255);}
//helpform:=TUIForm.Create('villageinfo.frm');
helpform.visible:=true;
//helpform.border:=false;
//villform['PANEL1'].visible:=false;
helpform['overimage'].visible:=false;
for i:=1 to 5 do
    helpform['img'+int2str(i)].DATA:=ResourceSprites[i];
for i := 1 to 9 do
    helpform['troops'+int2str(i)].DATA:=gmArmySprites[1][i];
end;

procedure gmVillageDeInit;
begin
gmUIDelete(pitsimg);
//helpform.Destroy;
if Assigned(villupgrade)then villupgrade.Destroy;
end;

procedure gmVillageKeyDown(Key:integer);
begin
  case Key of
    VK_ESCAPE:
    PauseGame;
  end;
end;


procedure gmVillageRun;
begin
gmVillageInitEx;
SetOnIdle(gmVillageIdle);
SetOnKeyDown(gmVillageKeyDown);

end;

end.
