{
  UniversalEngine by OXOTHuK
  version: 06.01.2007
}
unit ueMain;

interface

{$DEFINE NO_SOUND}
uses
  Windows,
  KOL,
  ueTypes;

const
  ueDll = 'ue.dll';

//---
function ueSndAdd(const Name1:string):integer;//external ueDll;
procedure ueSndKill(Sound:integer);
function ueSndPlay(Sound:integer;Loop:boolean;
  Volume:integer):integer;
procedure ueSndStop(sound:integer);
procedure ueSndStopChannel(Channel:integer);
function ueSndGetChannel(Sound:integer):integer;
procedure ueSndSetMusic(Sound:integer;Music:boolean);
//--- 
function ueRenderAddFont(DC:hdc = 0):byte;external ueDll;
procedure ueRenderDeleteFont(Font:byte);external ueDll;

//    
function ueRenderAddChar2Font(Font:byte;Char:cardinal;
  FontName:PChar;Size:word):byte;external ueDll;
function ueRenderAddCharEx2Font(Char:cardinal;Font:HFont):byte;external ueDll;
//  
procedure ueRenderSetSpace2Font(Font:byte;Space:word);external ueDll;
//    -    1(  )
procedure ueRenderSetCharInterval2Font(Font:byte;Value:word);external ueDll;
//    -    
function ueRenderFontTextLength(Font:byte;const Text:AnsiString):word;external ueDll;
// 
procedure ueRenderFontText(Font:byte;const Text:AnsiString;
  X,Y:integer;R,G,B,A:byte);external ueDll;
//     
function ueRenderFontTextEx(Font:byte;const Text:AnsiString;X,Y:integer;
  R,G,B,A:byte;LengthText:word):word;external ueDll;
//   - .   ,
//      ueRenderAddChar2Font,
//  ueRenderAddCharEx2Font
procedure ueRenderFontMakeCash(Font:byte);external ueDll;
//---

procedure ueRun;external ueDll;

//      array[0..255] of boolean
//      
function GetKeysPointer:pointer;external ueDll;

//
{
     -    ,
   ,      !!!
}
function addGraphContainer(Max:word):pointer;external ueDll;
procedure GraphContainerDraw(con:pointer;
  X,Y:single;R,G,B,A:byte;TileSize:single);external ueDll;
procedure deleteGraphContainer(con:pointer);external ueDll;
procedure GraphContainerUpdate(con:pointer;Value:single);external ueDll;
procedure GraphContainerSetCoeff(con:pointer;Value:single);external ueDll;
procedure GraphContainerSetMax(con:pointer;Value:single);external ueDll;
procedure GraphContainerSetDrawCells(con:pointer;Value:word);external ueDll;

procedure mainForceKeyDown(Key:integer);external ueDll;
procedure mainForceChar(Char:char);external ueDll;
procedure mainForceWheel(Value:word);external ueDll;
procedure mainForceCreate;external ueDll;
procedure mainForceDestroy;external ueDll;
procedure mainForceIdle;external ueDll;
procedure mainForceInit;external ueDll;
procedure mainForceDeInit;external ueDll;
procedure mainForceIntInit;external ueDll;

function GetResource(const RName:PChar;RType:TResourceType;
  var Dest:PStream):boolean;external ueDll;

function GetResourceInfo:TResourceInfo;external ueDll;

procedure ResourceEnum(RType:TResourceType;
  EnumProc:TResourceEnumProc);external ueDll;

function AddVarProc2Console(VarProc:PConsoleVarProc):boolean;external ueDll;

procedure AddString2Console(const Value:PChar);external ueDll;

procedure ConsoleExec(Value:PChar);external ueDll;

procedure SetWindowSize(Width,Height:integer);external ueDll;

function window_Height:integer;external ueDll;

function window_Width:integer;external ueDll;

function window_TickCount:cardinal;external ueDll;

procedure SetTickCount(Value:cardinal);external ueDll;

procedure SetFPS(Value:word);external ueDll;

procedure SetOnIdle(Value:TProc);external ueDll;

function GetOnIdle:TProc;external ueDll;

procedure SetOnQuit(Value:TProc);external ueDll;

function GetOnQuit:TProc;external ueDll;

procedure SetOnChar(Value:TChar);external ueDll;

function GetOnChar:TChar;external ueDll;

procedure SetOnKeyDown(Value:TKeyDown);external ueDll;

function GetOnKeyDown:TKeyDown;external ueDll;

procedure SetOnKeyUp(Value:TKeyDown);external ueDll;

function GetOnKeyUp:TKeyDown;external ueDll;

procedure SetOnMouseMove(Value:TMouseMove);external ueDll;

function GetOnMouseMove:TMouseMove;external ueDll;

procedure SetOnMouseKeyDown(Value:TMouseKeyDown);external ueDll;

function GetOnMouseKeyDown:TMouseKeyDown;external ueDll;

//procedure SetOnMouseWheel(Value:TMouseWheel);external ueDll;

//function GetOnMouseWheel:TMouseWheel;external ueDll;

procedure SetOnMouseKeyUp(Value:TMouseKeyDown);external ueDll;

function GetOnMouseKeyUp:TMouseKeyDown;external ueDll;

procedure mainLog(const Value:PChar);external ueDll;

procedure mainClose(Value:boolean);external ueDll;

procedure mainShutDownGame;external ueDll;

procedure ForceIdle;external ueDll;

function ueRenderInit(var RenderInfo:TRenderInfo):boolean;external ueDll;

function ueRenderDeInit(var RenderInfo:TRenderInfo):boolean;external ueDll;

procedure ueRenderFlip(var RenderInfo:TRenderInfo);external ueDll;

procedure ueRender2D;external ueDll;

procedure ueRenderClear(R,G,B:byte);external ueDll;

function ueRenderAddSprite(const Name:PChar):word;external ueDll;

procedure  ueRenderDeleteSprite(Sprite:word;ForceDelete:boolean = false);external ueDll;

procedure  ueLineWidth(width:integer);
procedure  ueRenderLine(X1,Y1,X2,Y2:integer;
  R1,G1,B1,A1,R2,G2,B2,A2:byte);external ueDll;

procedure  ueRenderRectangle(X,Y:integer;W,H:cardinal;R,G,B,A:byte;
  Fill:boolean);external ueDll;

procedure  ueRenderSprite(X,Y,Width,Height:integer;Sprite:word;
  Alpha:byte);external ueDll;

procedure  ueRenderSpriteColor(X,Y,Width,Height:integer;Sprite:word;
  R,G,B,Alpha:byte);external ueDll;

procedure ueRenderSpriteAngle(Angle:smallint;X,Y,Width,Height:integer;Sprite:word;
  Alpha:byte);external ueDll;

procedure ueRenderSpriteAngleColor(Angle:smallint;X,Y,Width,Height:integer;Sprite:word;
  Rc,Gc,Bc,Alpha:byte);external ueDll;

procedure ueRenderSpriteEx(X,Y,Width,Height:integer;Texture:word;
  Alpha:byte);external ueDll;

procedure ueRenderCutSprite(X,Y,ShiftX,ShiftY,
  CellWidth,CellHeight:integer;Sprite:word;Alpha:byte);external ueDll;

procedure ueRenderRawSprite(X,Y,Width,Height:integer;
  Sprite:word;Alpha:byte);external ueDll;

procedure ueRenderText(X,Y:integer;Sprite:word;const Text:PChar;
  Size:word;R,G,B,A:byte);external ueDll;

function ueRenderTextEx(X,Y:integer;Sprite:word;const Text:PChar;
  Size,TextLength:word;cR,cG,cB,A:byte):word;external ueDll;

function ueRenderTextEx2(X,Y:integer;Sprite:word;const Text:PChar;
  Size,Interval,TextLength:word;cR,cG,cB,A:byte):word;external ueDll;

function ueRenderTextLength(const Text:PChar):word;external ueDll;

procedure ueRenderBindSprite(Sprite:word);external ueDll;

procedure ueRenderUnBindSprite;external ueDll;

procedure ueRenderRawSpriteAngleColor(Angle:smallint;X,Y,Width,Height:integer;
  Sprite:word;Rc,Gc,Bc,Alpha:byte);external ueDll;

procedure ueRenderSetFirstFrameTime(Sprite:word;Time:cardinal);external ueDll;

procedure ueRenderTiledSprite(X,Y,W,H:integer;Sprite:word;
  R,G,B,A:byte);external ueDll;

implementation
uses   fmod, fmoderrors,fmodtypes,opengl;

procedure  ueLineWidth(width:integer);
begin
  glLineWidth(width);
end;

{$IFNDEF NO_SOUND}
type
  TSongType = record
    Module: PFMusicModule;
    Stream: PFSoundStream;
    Channel: Integer;
    Playing: Boolean;
  end;

const
MAX_SONGS=10;
var
sndInit:boolean=false;
FSongs: array [0..MAX_SONGS - 1] of TSongType;
  SongCount: Integer=0;
  {$ENDIF}

function ueSndAdd(const Name1:string):integer;//external ueDll;
{$IFNDEF NO_SOUND}
var
  Module: PFMusicModule;
  Stream: PFSoundStream;
  name:PChar;
  {$ENDIF}
begin
{$IFNDEF NO_SOUND}
name:='.\Wave\';
name:=PChar(name+name1);
if not sndInit then
  begin
   FMOD_Load(nil);
   try
    if FSOUND_SetOutput(FSOUND_OUTPUT_DSOUND) then
    if FSOUND_SetDriver(0) then
    if FSOUND_SetMixer(FSOUND_MIXER_QUALITY_AUTODETECT)then;
//    if not FSOUND_SetHWND(Handle);
    except
  end;
   if not FSOUND_Init(22050, 128, 0) then
    Halt;
   sndInit:=true;
  end;

    Stream := nil;
    Module := FMUSIC_LoadSong(name);
      if Module = nil then
      begin
        Stream := FSOUND_Stream_Open(Name, FSOUND_NORMAL or FSOUND_LOOP_NORMAL, 0, 0);
      end;

      if Module <> nil then
      begin
        FMUSIC_SetMasterVolume(Module, 255);
        if (FMUSIC_GetType(Module) = FMUSIC_TYPE_MOD) or (FMUSIC_GetType(Module) = FMUSIC_TYPE_S3M) then
          FMUSIC_SetPanSeperation(Module, 0.15);  // 15% crossover
      end;

      FSongs[SongCount].Module := Module;
      FSongs[SongCount].Stream := Stream;
      FSongs[SongCount].Playing := False;
    inc(songcount);
    result:=songcount-1;
    {$ENDIF}
end;

procedure ueSndStop(sound:integer);
begin
{$IFNDEF NO_SOUND}
  if FSongs[sound].Module <> nil then
    FMUSIC_StopSong(FSongs[sound].Module)
  else if FSongs[sound].Stream <> nil then
    FSOUND_Stream_Stop(FSongs[sound].Stream);
  FSongs[sound].Channel := -1;
  FSongs[sound].Playing := False;
  {$ENDIF}
end;


procedure ueSndKill(Sound:integer);
begin
{$IFNDEF NO_SOUND}
FSOUND_Stream_Close(FSongs[sound].Stream);
{$ENDIF}
end;

function ueSndPlay(Sound:integer;Loop:boolean;
  Volume:integer):integer;
  begin
  {$IFNDEF NO_SOUND}
  result:=0;
 if FSongs[sound].Playing then
    ueSndStop(sound);

  if FSongs[sound].Module <> nil then
  begin
    FSongs[sound].Playing := FMUSIC_PlaySong(FSongs[sound].Module);
    if not FSongs[sound].Playing then
//      Application.MessageBox(FMOD_ErrorString(FSOUND_GetError), 'Play song', MB_OK or MB_ICONHAND);
  end
  else if FSongs[sound].Stream <> nil then
  begin
    FSongs[sound].Channel := FSOUND_Stream_Play(FSOUND_FREE, FSongs[sound].Stream);
    FSongs[sound].Playing := FSongs[sound].Channel >= 0;
    if not loop then
        FSOUND_Stream_SetLoopCount(FSongs[sound].Stream,0);
    if not FSongs[sound].Playing then
    begin
      result:=1;
//      Application.MessageBox(FMOD_ErrorString(FSOUND_GetError), 'Play stream', MB_OK or MB_ICONHAND);
    end
    else
    begin
      FSOUND_SetPan(FSongs[sound].Channel, FSOUND_STEREOPAN);
      FSOUND_SetVolume(FSongs[sound].Channel, volume);
    end;
  end;
  {$ENDIF}
  end;

procedure ueSndStopChannel(Channel:integer);
begin

end;

function ueSndGetChannel(Sound:integer):integer;
begin

end;

procedure ueSndSetMusic(Sound:integer;Music:boolean);
begin

end;


end.
