unit gmCombatRules;

interface

type
TArmyData=record
troops:array[1..10]of integer;
troopslvls:array[1..10]of integer;
end;

const
ATTACKER=1;
DEFENDER=-1;
NONE=0;

LEG=1;  ATTACK=1;
PRA=2;  DEFEND=2;
IMP=3;  DEFEND2=3;

UNITDATA:array[1..3,1..3]of integer=
((40,35,90),
 (30,40,35),
 (70,40,25));

function AttackResults(var att,def:TArmyData):integer;
function RaidResults(var att,def:TArmyData):integer;

implementation
uses math;

function SumAttack(att:TArmyData):integer; //  
var
i:integer;
begin
result:=0;
  for i:=1 to 3 do result:=result+att.troops[i]*UNITDATA[i,ATTACK];
end;

  function SumInfDefend(att:TArmyData):integer;//   
  var
  i:integer;
  begin
  result:=0;
  for i:=1 to 3 do result:=result+att.troops[i]*UNITDATA[i,DEFEND];
  end;

  function SumCavDefend(att:TArmyData):integer;//   
  var
  i:integer;
  begin
  result:=0;
  for i:=1 to 3 do result:=result+att.troops[i]*UNITDATA[i,DEFEND2];
  end;

  function GetInfCoef(att:TArmyData):real;//  
  begin
    result:=1.0;
  end;

  function GetCavCoef(att:TArmyData):real;//  
  begin
    result:=0.0;
  end;

function SumDefend(att,def:TArmyData):integer; //    
begin
  result:=round(SumInfDefend(def)*GetInfCoef(att)+
                SumCavDefend(def)*GetCavCoef(att));
end;
//------------------------------------------
function KilledCoef(attsum,defsum:integer):real;
var
temp:integer;
begin
if attsum<defsum then
  begin
  temp:=attsum;
  attsum:=defsum;
  defsum:=temp;
  end;
if defsum<>0 then
result:=Power(defsum/attsum,1.5) else
  result:=1;
end;
//---------------------------------------

function GetWinner(attsum,defsum:integer):integer;
begin
  if attsum>defsum then
  result:=ATTACKER else
  if attsum<defsum then
  result:=DEFENDER else result:=NONE;
end;
//-----------------------------------
function AttackResults(var att,def:TArmyData):integer;
var
attsum,defsum:integer;
i:word;
begin
attsum:=SumAttack(att);
defsum:=SumDefend(att,def);
result:=GetWinner(attsum,defsum);
  if result=ATTACKER then
    begin
    for i:=1 to 3 do
      begin
      def.troops[i]:=0;
      att.troops[i]:=round(att.troops[i]*(1-KilledCoef(attsum,defsum)));
      end;
    end else
      if result=DEFENDER then
      begin
        for i:=1 to 3 do
          begin
          att.troops[i]:=0;
          def.troops[i]:=round(def.troops[i]*(1-KilledCoef(attsum,defsum)));
          end;
      end;
end;
//-----------------
function RaidCoef(attsum,defsum:Integer):real;
var
x:real;
begin
  x:=KilledCoef(attsum,defsum);
  result:=x/(1+x);
end;

function RaidResults(var att,def:TArmyData):integer;
var
attsum,defsum:integer;
i:word;
begin
result:=0;
attsum:=SumAttack(att);
defsum:=SumDefend(att,def);
result:=GetWinner(attsum,defsum);
  if result=ATTACKER then
    begin
    for i:=1 to 3 do
      begin
      def.troops[i]:=round(def.troops[i]*RaidCoef(attsum,defsum));
      att.troops[i]:=round(att.troops[i]*(1-RaidCoef(attsum,defsum)));
      end;
    end else
      if result=DEFENDER then
      begin
        for i:=1 to 3 do
          begin
          att.troops[i]:=round(att.troops[i]*RaidCoef(attsum,defsum));
          def.troops[i]:=round(def.troops[i]*(1-RaidCoef(attsum,defsum)));
          end;
      end;

  //
end;


end.
