unit frmPause;

interface
uses gmUi;
var
pauseform:TUiForm;

procedure PauseGame;
implementation
uses gmMenu,ueMain,gmGlobal,
gmMap,gmCity,gmVillage,gmAI,
frmHelpform;

procedure OnRestart(id:word);
begin
  SetLength(game.players,1);
  aiINIT;
  gmNewGame;
end;

procedure OnPauseMenu(id:word);
begin
case page of
  PAGE_MAP:gmMapDeInit;
  PAGE_VILL:gmVillageDeInit;
  PAGE_CITY:gmCityDeInit;
end;
//  ueSndStop(sndBackground);
  helpform.destroy;
  helpform:=nil;
  gmDeInitTop;
  gmMenuRun;
  aiInit;
  pauseform.Destroy;
  pauseform:=nil;
  needinit:=true;
end;

procedure onQuit(id:word);
begin
  mainShutDownGame;
end;


procedure OnResumeGame(id:word);
begin
//ueSndPlay(sndBackground,true,100);
pauseform.Destroy;
pauseform:=nil;
end;


procedure PauseGame;
begin
if gmUI_Status<>DIALOG then
if not Assigned(pauseform) then
begin
pauseform:=TUIForm.Create('pause.frm');
pauseform['quit'].OnPress:=OnQuit;
pauseform['restart'].OnPress:=OnRestart;
pauseform['menu'].OnPress:=OnPauseMenu;
pauseform['resume'].OnPress:=OnResumeGame;
end;
end;

end.
