{
     
}
unit gmMain;

interface

uses
  KOL,
  ueTypes,
  ueMain,
  gmMenu,
  gmUI;

var
  gmMain_OnQuit:TProc = nil;
  gmMain_OnMouseMove:TMouseMove = nil;
  gmMenu_OnMouseKeyDown:TMouseKeyDown = nil;
  gmMenu_OnKeyDown:TKeyDOwn = nil;

  gmMain_Width,gmMain_Height:word;
  gmMain_Font:word;
  gmMain_CursorX,gmMain_CursorY:integer;

procedure gmMainRun;

implementation

procedure gmMainQuit;
begin
  gmUIDeInit;
  if Assigned(gmMain_OnQuit) then
    gmMain_OnQuit;
end;

procedure gmMainInit;
begin
  gmUIInit;
  
  gmMenuInit;

  ueRender2D;

  gmMain_Font:=ueRenderAddSprite('mainFont');

  SetOnIdle(gmMenuRun);
end;

procedure gmMainMouseMove(X,Y:integer);
begin
  gmMain_CursorX:=X;
  gmMain_CursorY:=Y;

  gmUIOnMouseMove(gmMain_CursorX,gmMain_CursorY);

  if Assigned(gmMain_OnMouseMove) then
    gmMain_OnMouseMove(gmMain_CursorX,gmMain_CursorY);
end;

procedure gmMainMouseKeyDown(X,Y:integer;Left,Right:boolean);
begin
  gmUIOnMouseKeyDown(gmMain_CursorX,gmMain_CursorY,Left,Right);

  if Assigned(gmMenu_OnMouseKeyDown) then
    gmMenu_OnMouseKeyDown(gmMain_CursorX,gmMain_CursorY,Left,Right);
end;

procedure gmMainKeyDown(Key:integer);
begin
  gmUIOnKeyDown(Key);

  if Assigned(gmMenu_OnKeyDown) then
    gmMenu_OnKeyDown(Key);
end;

procedure gmMainRun;
begin
  gmMain_Width:=800;
  gmMain_Height:=600;
  SetOnQuit(gmMainQuit);
  SetWindowSize(gmMain_Width,gmMain_Height);
  SetOnIdle(gmMainInit);
  SetOnMouseMove(gmMainMouseMove);
  SetOnMouseKeyDown(gmMainMouseKeyDown);
  SetOnKeyDown(gmMainKeyDown);
  ueRun;
end;

end.
